function [residual, g1, g2, g3] = BKK3C_fg2nfKR_dynamic(y, x, params, steady_state, it_)
%
% Status : Computes dynamic model for Dynare
%
% Inputs :
%   y         [#dynamic variables by 1] double    vector of endogenous variables in the order stored
%                                                 in M_.lead_lag_incidence; see the Manual
%   x         [nperiods by M_.exo_nbr] double     matrix of exogenous variables (in declaration order)
%                                                 for all simulation periods
%   steady_state  [M_.endo_nbr by 1] double       vector of steady state values
%   params    [M_.param_nbr by 1] double          vector of parameter values in declaration order
%   it_       scalar double                       time period for exogenous variables for which to evaluate the model
%
% Outputs:
%   residual  [M_.endo_nbr by 1] double    vector of residuals of the dynamic model equations in order of 
%                                          declaration of the equations.
%                                          Dynare may prepend auxiliary equations, see M_.aux_vars
%   g1        [M_.endo_nbr by #dynamic variables] double    Jacobian matrix of the dynamic model equations;
%                                                           rows: equations in order of declaration
%                                                           columns: variables in order stored in M_.lead_lag_incidence followed by the ones in M_.exo_names
%   g2        [M_.endo_nbr by (#dynamic variables)^2] double   Hessian matrix of the dynamic model equations;
%                                                              rows: equations in order of declaration
%                                                              columns: variables in order stored in M_.lead_lag_incidence followed by the ones in M_.exo_names
%   g3        [M_.endo_nbr by (#dynamic variables)^3] double   Third order derivative matrix of the dynamic model equations;
%                                                              rows: equations in order of declaration
%                                                              columns: variables in order stored in M_.lead_lag_incidence followed by the ones in M_.exo_names
%
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(63, 1);
T16 = (params(4)-1)/params(4);
T32 = params(25)*y(25)^T16+params(26)*(params(21)*y(28))^T16+params(27)*(params(23)*y(31))^T16;
T33 = params(4)/(params(4)-1);
T37 = params(37)/2;
T43 = y(28)/y(25)*y(4)/y(7)-1;
T48 = params(38)/2;
T53 = y(28)/y(31)*y(10)/y(7)-1;
T58 = params(39)/2;
T62 = y(4)*y(31)/y(25)/y(10)-1;
T88 = params(28)*(params(19)*y(26))^T16+params(29)*y(29)^T16+params(30)*(params(24)*y(32))^T16;
T92 = params(40)/2;
T98 = y(26)/y(29)*y(8)/y(5)-1;
T103 = params(41)/2;
T108 = y(8)*y(32)/y(29)/y(11)-1;
T113 = params(42)/2;
T117 = y(11)*y(26)/y(32)/y(5)-1;
T143 = params(31)*(params(20)*y(27))^T16+params(32)*(params(22)*y(30))^T16+params(33)*y(33)^T16;
T147 = params(43)/2;
T153 = y(27)/y(30)*y(9)/y(6)-1;
T158 = params(44)/2;
T163 = y(30)/y(33)*y(12)/y(9)-1;
T168 = params(45)/2;
T172 = y(12)*y(27)/y(33)/y(6)-1;
T189 = (y(67)/y(1)-params(3))^2;
T202 = (y(68)/y(2)-params(3))^2;
T215 = (y(69)/y(3)-params(3))^2;
T224 = params(5)*y(79)^(-params(2));
T229 = 1-params(46)*(y(94)/y(19)-params(3));
T230 = T224/T229;
T234 = params(46)/2;
T235 = params(3)^2;
T239 = 1+y(91)-params(3)-T234*(T235-(y(94)/y(19))^2);
T241 = y(16)^(-params(2));
T243 = 1-params(46)*(y(67)/y(1)-params(3));
T249 = params(5)*y(80)^(-params(2));
T254 = 1-params(46)*(y(95)/y(20)-params(3));
T255 = T249/T254;
T262 = 1+y(92)-params(3)-T234*(T235-(y(95)/y(20))^2);
T264 = y(17)^(-params(2));
T266 = 1-params(46)*(y(68)/y(2)-params(3));
T272 = params(5)*y(81)^(-params(2));
T277 = 1-params(46)*(y(96)/y(21)-params(3));
T278 = T272/T277;
T285 = 1+y(93)-params(3)-T234*(T235-(y(96)/y(21))^2);
T287 = y(18)^(-params(2));
T289 = 1-params(46)*(y(69)/y(3)-params(3));
T346 = y(25)^2;
T347 = (-y(28))/T346;
T358 = y(25)*y(85)/y(82)/y(28)-1;
T359 = params(37)*y(61)*T358;
T360 = y(85)/y(82)/y(28);
T367 = y(4)*(-y(31))/T346/y(10);
T375 = y(25)*y(88)/y(82)/y(31)-1;
T376 = params(39)*y(61)*T375;
T381 = (-1)/params(4);
T383 = params(25)*y(25)^T381;
T384 = 1/(params(4)-1);
T385 = T32^T384;
T398 = y(31)*y(85)/y(88)/y(28)-1;
T399 = params(38)*y(61)*T398;
T403 = y(28)^2;
T404 = y(31)*(-y(85))/y(88)/T403;
T408 = y(4)/y(7)/y(25);
T413 = y(25)*(-y(85))/y(82)/T403;
T417 = params(26)*(params(21)*y(28))^T381;
T428 = y(31)^2;
T429 = y(25)*(-y(88))/y(82)/T428;
T434 = y(10)*(-y(28))/T428/y(7);
T442 = params(27)*(params(23)*y(31))^T381;
T457 = y(29)*y(83)/y(86)/y(26)-1;
T458 = params(40)*y(62)*T457;
T462 = y(26)^2;
T463 = y(29)*(-y(83))/y(86)/T462;
T468 = y(11)/y(5)/y(32);
T476 = y(32)*y(83)/y(89)/y(26)-1;
T477 = params(42)*y(62)*T476;
T481 = y(83)*(-y(32))/T462/y(89);
T485 = params(28)*(params(19)*y(26))^T381;
T486 = T88^T384;
T491 = y(29)^2;
T494 = y(8)*(-y(32))/T491/y(11);
T501 = y(29)*y(89)/y(86)/y(32)-1;
T502 = params(41)*y(62)*T501;
T503 = y(89)/y(86)/y(32);
T509 = y(8)*(-y(26))/T491/y(5);
T517 = params(29)*y(29)^T381;
T524 = y(32)^2;
T525 = y(26)*(-y(11))/y(5)/T524;
T533 = y(8)/y(11)/y(29);
T539 = y(29)*(-y(89))/y(86)/T524;
T543 = params(30)*(params(24)*y(32))^T381;
T558 = y(30)*y(84)/y(87)/y(27)-1;
T559 = params(43)*y(62)*T558;
T563 = y(27)^2;
T564 = y(30)*(-y(84))/y(87)/T563;
T569 = y(6)/y(12)/y(33);
T577 = y(33)*y(84)/y(90)/y(27)-1;
T578 = params(45)*y(62)*T577;
T581 = y(33)*(-y(84))/y(90)/T563;
T585 = params(31)*(params(20)*y(27))^T381;
T586 = T143^T384;
T599 = y(33)*y(87)/y(90)/y(30)-1;
T600 = params(44)*y(62)*T599;
T604 = y(30)^2;
T605 = y(33)*(-y(87))/y(90)/T604;
T611 = y(9)*(-y(27))/T604/y(6);
T619 = params(32)*(params(22)*y(30))^T381;
T626 = y(33)^2;
T627 = y(27)*(-y(12))/y(6)/T626;
T630 = y(84)/y(90)/y(27);
T636 = y(12)*(-y(30))/T626/y(9);
T644 = params(33)*y(33)^T381;
T654 = y(19)^(params(1)-1);
T655 = y(64)*y(52)*params(1)*T654;
T657 = y(22)^(1-params(1));
T661 = y(19)^params(1);
T664 = y(22)^(-params(1));
T672 = y(20)^(params(1)-1);
T673 = params(1)*y(65)*y(56)*T672;
T674 = y(23)^(1-params(1));
T678 = y(20)^params(1);
T680 = y(23)^(-params(1));
T688 = y(21)^(params(1)-1);
T689 = params(1)*y(66)*y(60)*T688;
T690 = y(24)^(1-params(1));
T694 = y(21)^params(1);
T696 = y(24)^(-params(1));
T819 = params(9)*y(41)*(-0.5)*(y(27)*params(49)+y(30)*params(52)+y(33)*params(55)-T690*T694*y(66)*params(55))/params(7);
residual(1) = (-y(16))-y(67)+T32^T33-T37*T43^2-T48*T53^2-T58*T62^2;
residual(2) = (-y(17))-y(68)+T88^T33-T92*T98^2-T103*T108^2-T113*T117^2;
residual(3) = (-y(18))-y(69)+T143^T33-T147*T153^2-T158*T163^2-T168*T172^2;
residual(4) = y(67)+(-y(19))+(1-params(3))*y(1)-y(1)*params(46)*T189;
residual(5) = y(68)+(-y(20))+(1-params(3))*y(2)-params(46)*y(2)*T202;
residual(6) = y(69)+(-y(21))+(1-params(3))*y(3)-params(46)*y(3)*T215;
residual(7) = T230*T239-T241/T243;
residual(8) = T255*T262-T264/T266;
residual(9) = T278*T285-T287/T289;
residual(10) = T241*(1-params(57))*y(37)-params(56)*y(22)^params(6);
residual(11) = T264*(1-params(57))*y(38)-params(56)*y(23)^params(6);
residual(12) = T287*(1-params(57))*y(39)-params(56)*y(24)^params(6);
lhs =y(40);
rhs =T264/T241*params(35);
residual(13)= lhs-rhs;
lhs =y(41);
rhs =T287/T241*params(36);
residual(14)= lhs-rhs;
lhs =y(42);
rhs =y(41)/y(40);
residual(15)= lhs-rhs;
lhs =y(61);
rhs =T224/T241;
residual(16)= lhs-rhs;
lhs =y(62);
rhs =T249/T264;
residual(17)= lhs-rhs;
lhs =y(63);
rhs =T272/T287;
residual(18)= lhs-rhs;
lhs =y(43)+y(4)*params(37)*T43*T347/y(7)+T359*T360+params(39)*T62*T367+y(88)*T376/y(82)/y(31);
rhs =T383*T385;
residual(19)= lhs-rhs;
lhs =y(46)+y(10)*params(38)*T53/y(31)/y(7)+T399*T404+params(37)*T43*T408+T359*T413;
rhs =T385*T417;
residual(20)= lhs-rhs;
lhs =y(49)+y(4)*params(39)*T62/y(25)/y(10)+T376*T429+params(38)*T53*T434+y(85)*T399/y(88)/y(28);
rhs =T385*T442;
residual(21)= lhs-rhs;
lhs =y(44)+y(8)*params(40)*T98/y(29)/y(5)+T458*T463+params(42)*T117*T468+T477*T481;
rhs =T485*T486;
residual(22)= lhs-rhs;
lhs =y(47)+params(41)*T108*T494+T502*T503+params(40)*T98*T509+y(83)*T458/y(86)/y(26);
rhs =T486*T517;
residual(23)= lhs-rhs;
lhs =y(50)+params(42)*T117*T525+y(32)*y(83)*T477/y(89)+params(41)*T108*T533+T502*T539;
rhs =T486*T543;
residual(24)= lhs-rhs;
lhs =y(45)+y(9)*params(43)*T153/y(30)/y(6)+T559*T564+params(45)*T172*T569+T578*T581;
rhs =T585*T586;
residual(25)= lhs-rhs;
lhs =y(48)+y(12)*params(44)*T163/y(33)/y(9)+T600*T605+params(43)*T153*T611+y(84)*T559/y(87)/y(27);
rhs =T586*T619;
residual(26)= lhs-rhs;
lhs =y(51)+params(45)*T172*T627+T578*T630+params(44)*T163*T636+y(87)*T600/y(90)/y(30);
rhs =T586*T644;
residual(27)= lhs-rhs;
lhs =y(34);
rhs =T655*T657;
residual(28)= lhs-rhs;
lhs =y(37);
rhs =y(64)*y(52)*(1-params(1))*T661*T664;
residual(29)= lhs-rhs;
lhs =y(35);
rhs =T673*T674;
residual(30)= lhs-rhs;
lhs =y(38);
rhs =(1-params(1))*y(65)*y(56)*T678*T680;
residual(31)= lhs-rhs;
lhs =y(36);
rhs =T689*T690;
residual(32)= lhs-rhs;
lhs =y(39);
rhs =(1-params(1))*y(66)*y(60)*T694*T696;
residual(33)= lhs-rhs;
lhs =y(52);
rhs =y(43);
residual(34)= lhs-rhs;
lhs =y(44);
rhs =(1+params(13))*y(53)/params(19);
residual(35)= lhs-rhs;
lhs =y(45);
rhs =(1+params(14))*y(54)/params(20);
residual(36)= lhs-rhs;
lhs =y(46);
rhs =(1+params(15))*y(55)/params(21);
residual(37)= lhs-rhs;
lhs =y(56);
rhs =y(47);
residual(38)= lhs-rhs;
lhs =y(48);
rhs =(1+params(16))*y(57)/params(22);
residual(39)= lhs-rhs;
lhs =y(49);
rhs =(1+params(17))*y(58)/params(23);
residual(40)= lhs-rhs;
lhs =y(50);
rhs =(1+params(16))*y(59)/params(22);
residual(41)= lhs-rhs;
lhs =y(60);
rhs =y(51);
residual(42)= lhs-rhs;
lhs =y(52);
rhs =y(40)*y(53);
residual(43)= lhs-rhs;
lhs =y(55);
rhs =y(40)*y(56);
residual(44)= lhs-rhs;
lhs =y(58);
rhs =y(40)*y(59);
residual(45)= lhs-rhs;
lhs =y(52);
rhs =y(41)*y(54);
residual(46)= lhs-rhs;
lhs =y(55);
rhs =y(41)*y(57);
residual(47)= lhs-rhs;
lhs =y(58);
rhs =y(41)*y(60);
residual(48)= lhs-rhs;
lhs =y(25)*params(7)+y(26)*params(8)+y(27)*params(9);
rhs =y(64)*params(7)*T657*T661;
residual(49)= lhs-rhs;
lhs =y(28)*params(7)+y(29)*params(8)+y(30)*params(9);
rhs =y(65)*params(8)*T674*T678;
residual(50)= lhs-rhs;
lhs =y(31)*params(7)+y(32)*params(8)+y(33)*params(9);
rhs =y(66)*params(9)*T690*T694;
residual(51)= lhs-rhs;
lhs =log(y(64));
rhs =params(10)*log(y(13))+x(it_, 1);
residual(52)= lhs-rhs;
lhs =log(y(65));
rhs =params(11)*log(y(14))+x(it_, 2);
residual(53)= lhs-rhs;
lhs =log(y(66));
rhs =params(12)*log(y(15))+x(it_, 3);
residual(54)= lhs-rhs;
lhs =y(71);
rhs =T819/y(43);
residual(55)= lhs-rhs;
lhs =y(70);
rhs =(y(25)*params(47)+y(28)*params(50)+y(31)*params(53)-T657*T661*y(64)*params(47))/y(43)-y(71);
residual(56)= lhs-rhs;
lhs =y(72);
rhs =y(46)/y(43);
residual(57)= lhs-rhs;
lhs =y(73);
rhs =y(49)/y(43);
residual(58)= lhs-rhs;
lhs =y(74);
rhs =y(28)*(1-y(72));
residual(59)= lhs-rhs;
lhs =y(75);
rhs =y(31)*(1-y(73));
residual(60)= lhs-rhs;
lhs =y(76);
rhs =y(31)+y(25)+y(28)-y(74)-y(75)-y(64)*T657*T661;
residual(61)= lhs-rhs;
lhs =y(77);
rhs =y(64)*T657*T661;
residual(62)= lhs-rhs;
lhs =y(78);
rhs =y(65)*T674*T678;
residual(63)= lhs-rhs;
if nargout >= 2,
  g1 = zeros(63, 99);

  %
  % Jacobian matrix
  %

T864 = getPowerDeriv(y(16),(-params(2)),1);
T884 = params(5)*getPowerDeriv(y(79),(-params(2)),1);
T889 = getPowerDeriv(y(17),(-params(2)),1);
T902 = params(5)*getPowerDeriv(y(80),(-params(2)),1);
T907 = getPowerDeriv(y(18),(-params(2)),1);
T920 = params(5)*getPowerDeriv(y(81),(-params(2)),1);
T962 = getPowerDeriv(y(19),params(1),1);
T1012 = getPowerDeriv(y(20),params(1),1);
T1058 = getPowerDeriv(y(21),params(1),1);
T1074 = getPowerDeriv(y(22),1-params(1),1);
T1092 = getPowerDeriv(y(23),1-params(1),1);
T1106 = getPowerDeriv(y(24),1-params(1),1);
T1121 = y(28)/y(25)/y(7);
T1126 = y(31)/y(25)/y(10);
T1152 = params(25)*getPowerDeriv(y(25),T16,1);
T1153 = getPowerDeriv(T32,T33,1);
T1158 = y(4)*(-y(28))/(y(25)*y(25))/y(7);
T1164 = y(4)*(-y(31))/(y(25)*y(25))/y(10);
T1193 = params(39)*y(61)*y(88)/y(82)/y(31);
T1200 = getPowerDeriv(T32,T384,1);
T1236 = params(37)*y(61)*y(25)*(-y(85))/(y(82)*y(82))/y(28);
T1244 = params(39)*y(61)*y(25)*(-y(88))/(y(82)*y(82))/y(31);
T1265 = (-(y(26)/y(29)*y(8)))/(y(5)*y(5));
T1271 = (-(y(11)*y(26)/y(32)))/(y(5)*y(5));
T1302 = params(28)*params(19)*getPowerDeriv(params(19)*y(26),T16,1);
T1303 = getPowerDeriv(T88,T33,1);
T1307 = y(8)*1/y(29)/y(5);
T1313 = y(11)*1/y(32)/y(5);
T1324 = params(40)*y(62)*(-(y(29)*y(83)/y(86)))/(y(26)*y(26));
T1339 = params(42)*y(62)*(-(y(32)*y(83)/y(89)))/(y(26)*y(26));
T1352 = getPowerDeriv(T88,T384,1);
T1385 = params(40)*y(62)*y(29)*1/y(86)/y(26);
T1395 = params(42)*y(62)*y(32)*1/y(89)/y(26);
T1411 = (-(y(27)/y(30)*y(9)))/(y(6)*y(6));
T1417 = (-(y(12)*y(27)/y(33)))/(y(6)*y(6));
T1448 = params(31)*params(20)*getPowerDeriv(params(20)*y(27),T16,1);
T1449 = getPowerDeriv(T143,T33,1);
T1453 = y(9)*1/y(30)/y(6);
T1459 = y(12)*1/y(33)/y(6);
T1470 = params(43)*y(62)*(-(y(30)*y(84)/y(87)))/(y(27)*y(27));
T1485 = params(45)*y(62)*(-(y(33)*y(84)/y(90)))/(y(27)*y(27));
T1496 = getPowerDeriv(T143,T384,1);
T1535 = params(43)*y(62)*y(30)*1/y(87)/y(27);
T1545 = params(45)*y(62)*y(33)*1/y(90)/y(27);
T1563 = (-(y(28)/y(25)*y(4)))/(y(7)*y(7));
T1568 = (-(y(28)/y(31)*y(10)))/(y(7)*y(7));
T1599 = params(26)*params(21)*getPowerDeriv(params(21)*y(28),T16,1);
T1603 = y(4)*1/y(25)/y(7);
T1609 = y(10)*1/y(31)/y(7);
T1623 = params(37)*y(61)*(-(y(25)*y(85)/y(82)))/(y(28)*y(28));
T1639 = params(38)*y(61)*(-(y(31)*y(85)/y(88)))/(y(28)*y(28));
T1685 = params(37)*y(61)*y(25)*1/y(82)/y(28);
T1693 = params(38)*y(61)*y(31)*1/y(88)/y(28);
T1711 = y(26)/y(29)/y(5);
T1715 = y(32)/y(29)/y(11);
T1741 = params(29)*getPowerDeriv(y(29),T16,1);
T1746 = y(8)*(-y(26))/(y(29)*y(29))/y(5);
T1752 = y(8)*(-y(32))/(y(29)*y(29))/y(11);
T1763 = params(40)*y(62)*y(83)/y(86)/y(26);
T1821 = params(40)*y(62)*y(29)*(-y(83))/(y(86)*y(86))/y(26);
T1831 = params(41)*y(62)*y(29)*(-y(89))/(y(86)*y(86))/y(32);
T1848 = y(27)/y(30)/y(6);
T1854 = (-(y(30)/y(33)*y(12)))/(y(9)*y(9));
T1882 = params(32)*params(22)*getPowerDeriv(params(22)*y(30),T16,1);
T1887 = y(9)*(-y(27))/(y(30)*y(30))/y(6);
T1891 = y(12)*1/y(33)/y(9);
T1902 = params(43)*y(62)*y(84)/y(87)/y(27);
T1917 = params(44)*y(62)*(-(y(33)*y(87)/y(90)))/(y(30)*y(30));
T1969 = params(43)*y(62)*y(30)*(-y(84))/(y(87)*y(87))/y(27);
T1977 = params(44)*y(62)*y(33)*1/y(90)/y(30);
T1992 = y(28)/y(31)/y(7);
T1998 = (-(y(4)*y(31)/y(25)))/(y(10)*y(10));
T2025 = params(27)*params(23)*getPowerDeriv(params(23)*y(31),T16,1);
T2030 = y(10)*(-y(28))/(y(31)*y(31))/y(7);
T2034 = y(4)*1/y(25)/y(10);
T2046 = params(39)*y(61)*(-(y(25)*y(88)/y(82)))/(y(31)*y(31));
T2063 = params(38)*y(61)*y(85)/y(88)/y(28);
T2107 = params(39)*y(61)*y(25)*1/y(82)/y(31);
T2116 = params(38)*y(61)*y(31)*(-y(85))/(y(88)*y(88))/y(28);
T2135 = (-(y(8)*y(32)/y(29)))/(y(11)*y(11));
T2139 = y(26)/y(32)/y(5);
T2170 = params(30)*params(24)*getPowerDeriv(params(24)*y(32),T16,1);
T2172 = y(8)*1/y(29)/y(11);
T2179 = y(11)*(-y(26))/(y(32)*y(32))/y(5);
T2190 = params(42)*y(62)*y(83)/y(89)/y(26);
T2208 = params(41)*y(62)*(-(y(29)*y(89)/y(86)))/(y(32)*y(32));
T2250 = params(42)*y(62)*y(32)*(-y(83))/(y(89)*y(89))/y(26);
T2257 = params(41)*y(62)*y(29)*1/y(86)/y(32);
T2272 = y(30)/y(33)/y(9);
T2276 = y(27)/y(33)/y(6);
T2305 = params(33)*getPowerDeriv(y(33),T16,1);
T2310 = y(12)*(-y(30))/(y(33)*y(33))/y(9);
T2316 = y(12)*(-y(27))/(y(33)*y(33))/y(6);
T2342 = params(44)*y(62)*y(87)/y(90)/y(30);
T2387 = params(45)*y(62)*y(33)*(-y(84))/(y(90)*y(90))/y(27);
T2397 = params(44)*y(62)*y(33)*(-y(87))/(y(90)*y(90))/y(30);
  g1(1,16)=(-1);
  g1(1,4)=(-(T37*T1121*2*T43))-T58*T1126*2*T62;
  g1(1,25)=T1152*T1153-T37*2*T43*T1158-T58*2*T62*T1164;
  g1(1,7)=(-(T37*2*T43*T1563))-T48*T1568*2*T53;
  g1(1,28)=T1153*T1599-T37*2*T43*T1603-T48*2*T53*T1609;
  g1(1,10)=(-(T48*2*T53*T1992))-T58*2*T62*T1998;
  g1(1,31)=T1153*T2025-T48*2*T53*T2030-T58*2*T62*T2034;
  g1(1,67)=(-1);
  g1(2,17)=(-1);
  g1(2,5)=(-(T92*T1265*2*T98))-T113*T1271*2*T117;
  g1(2,26)=T1302*T1303-T92*2*T98*T1307-T113*2*T117*T1313;
  g1(2,8)=(-(T92*2*T98*T1711))-T103*T1715*2*T108;
  g1(2,29)=T1303*T1741-T92*2*T98*T1746-T103*2*T108*T1752;
  g1(2,11)=(-(T103*2*T108*T2135))-T113*2*T117*T2139;
  g1(2,32)=T1303*T2170-T103*2*T108*T2172-T113*2*T117*T2179;
  g1(2,68)=(-1);
  g1(3,18)=(-1);
  g1(3,6)=(-(T147*T1411*2*T153))-T168*T1417*2*T172;
  g1(3,27)=T1448*T1449-T147*2*T153*T1453-T168*2*T172*T1459;
  g1(3,9)=(-(T147*2*T153*T1848))-T158*T1854*2*T163;
  g1(3,30)=T1449*T1882-T147*2*T153*T1887-T158*2*T163*T1891;
  g1(3,12)=(-(T158*2*T163*T2272))-T168*2*T172*T2276;
  g1(3,33)=T1449*T2305-T158*2*T163*T2310-T168*2*T172*T2316;
  g1(3,69)=(-1);
  g1(4,1)=1-params(3)-(params(46)*T189+y(1)*params(46)*(-y(67))/(y(1)*y(1))*2*(y(67)/y(1)-params(3)));
  g1(4,19)=(-1);
  g1(4,67)=1-y(1)*params(46)*2*(y(67)/y(1)-params(3))*1/y(1);
  g1(5,2)=1-params(3)-(params(46)*T202+params(46)*y(2)*(-y(68))/(y(2)*y(2))*2*(y(68)/y(2)-params(3)));
  g1(5,20)=(-1);
  g1(5,68)=1-params(46)*y(2)*2*(y(68)/y(2)-params(3))*1/y(2);
  g1(6,3)=1-params(3)-(params(46)*T215+params(46)*y(3)*(-y(69))/(y(3)*y(3))*2*(y(69)/y(3)-params(3)));
  g1(6,21)=(-1);
  g1(6,69)=1-params(46)*y(3)*2*(y(69)/y(3)-params(3))*1/y(3);
  g1(7,16)=(-(T864/T243));
  g1(7,79)=T239*T884/T229;
  g1(7,1)=(-((-(T241*(-(params(46)*(-y(67))/(y(1)*y(1))))))/(T243*T243)));
  g1(7,19)=T239*(-(T224*(-(params(46)*(-y(94))/(y(19)*y(19))))))/(T229*T229)+T230*(-(T234*(-((-y(94))/(y(19)*y(19))*2*y(94)/y(19)))));
  g1(7,91)=T230;
  g1(7,67)=(-((-(T241*(-(params(46)*1/y(1)))))/(T243*T243)));
  g1(7,94)=T239*(-(T224*(-(params(46)*1/y(19)))))/(T229*T229)+T230*(-(T234*(-(2*y(94)/y(19)*1/y(19)))));
  g1(8,17)=(-(T889/T266));
  g1(8,80)=T262*T902/T254;
  g1(8,2)=(-((-(T264*(-(params(46)*(-y(68))/(y(2)*y(2))))))/(T266*T266)));
  g1(8,20)=T262*(-(T249*(-(params(46)*(-y(95))/(y(20)*y(20))))))/(T254*T254)+T255*(-(T234*(-((-y(95))/(y(20)*y(20))*2*y(95)/y(20)))));
  g1(8,92)=T255;
  g1(8,68)=(-((-(T264*(-(params(46)*1/y(2)))))/(T266*T266)));
  g1(8,95)=T262*(-(T249*(-(params(46)*1/y(20)))))/(T254*T254)+T255*(-(T234*(-(2*y(95)/y(20)*1/y(20)))));
  g1(9,18)=(-(T907/T289));
  g1(9,81)=T285*T920/T277;
  g1(9,3)=(-((-(T287*(-(params(46)*(-y(69))/(y(3)*y(3))))))/(T289*T289)));
  g1(9,21)=T285*(-(T272*(-(params(46)*(-y(96))/(y(21)*y(21))))))/(T277*T277)+T278*(-(T234*(-((-y(96))/(y(21)*y(21))*2*y(96)/y(21)))));
  g1(9,93)=T278;
  g1(9,69)=(-((-(T287*(-(params(46)*1/y(3)))))/(T289*T289)));
  g1(9,96)=T285*(-(T272*(-(params(46)*1/y(21)))))/(T277*T277)+T278*(-(T234*(-(2*y(96)/y(21)*1/y(21)))));
  g1(10,16)=(1-params(57))*y(37)*T864;
  g1(10,22)=(-(params(56)*getPowerDeriv(y(22),params(6),1)));
  g1(10,37)=T241*(1-params(57));
  g1(11,17)=(1-params(57))*y(38)*T889;
  g1(11,23)=(-(params(56)*getPowerDeriv(y(23),params(6),1)));
  g1(11,38)=T264*(1-params(57));
  g1(12,18)=(1-params(57))*y(39)*T907;
  g1(12,24)=(-(params(56)*getPowerDeriv(y(24),params(6),1)));
  g1(12,39)=T287*(1-params(57));
  g1(13,16)=(-(params(35)*(-(T264*T864))/(T241*T241)));
  g1(13,17)=(-(params(35)*T889/T241));
  g1(13,40)=1;
  g1(14,16)=(-(params(36)*(-(T287*T864))/(T241*T241)));
  g1(14,18)=(-(params(36)*T907/T241));
  g1(14,41)=1;
  g1(15,40)=(-((-y(41))/(y(40)*y(40))));
  g1(15,41)=(-(1/y(40)));
  g1(15,42)=1;
  g1(16,16)=(-((-(T224*T864))/(T241*T241)));
  g1(16,79)=(-(T884/T241));
  g1(16,61)=1;
  g1(17,17)=(-((-(T249*T889))/(T264*T264)));
  g1(17,80)=(-(T902/T264));
  g1(17,62)=1;
  g1(18,18)=(-((-(T272*T907))/(T287*T287)));
  g1(18,81)=(-(T920/T287));
  g1(18,63)=1;
  g1(19,4)=(params(37)*T43*T347+y(4)*T347*params(37)*T1121)/y(7)+T367*params(39)*T1126+params(39)*T62*(-y(31))/T346/y(10);
  g1(19,25)=y(4)*(T347*params(37)*T1158+params(37)*T43*(-((-y(28))*2*y(25)))/(T346*T346))/y(7)+T360*params(37)*y(61)*T360+T367*params(39)*T1164+params(39)*T62*y(4)*(-((-y(31))*2*y(25)))/(T346*T346)/y(10)+y(88)*T1193/y(82)/y(31)-(T385*params(25)*getPowerDeriv(y(25),T381,1)+T383*T1152*T1200);
  g1(19,82)=T360*T1236+T359*(-y(85))/(y(82)*y(82))/y(28)+(y(82)*y(88)*T1244-y(88)*T376)/(y(82)*y(82))/y(31);
  g1(19,7)=(y(7)*y(4)*T347*params(37)*T1563-y(4)*params(37)*T43*T347)/(y(7)*y(7));
  g1(19,28)=y(4)*(T347*params(37)*T1603+params(37)*T43*(-1)/T346)/y(7)+T360*T1623+T359*(-(y(85)/y(82)))/(y(28)*y(28))-T383*T1200*T1599;
  g1(19,85)=T360*T1685+T359*1/y(82)/y(28);
  g1(19,10)=T367*params(39)*T1998+params(39)*T62*(-(y(4)*(-y(31))/T346))/(y(10)*y(10));
  g1(19,31)=T367*params(39)*T2034+params(39)*T62*y(4)*(-1)/T346/y(10)+(y(31)*y(88)*T2046/y(82)-y(88)*T376/y(82))/(y(31)*y(31))-T383*T1200*T2025;
  g1(19,88)=(T376+y(88)*T2107)/y(82)/y(31);
  g1(19,43)=1;
  g1(19,61)=T360*params(37)*T358+y(88)*params(39)*T375/y(82)/y(31);
  g1(20,4)=T408*params(37)*T1121+params(37)*T43*1/y(7)/y(25);
  g1(20,25)=T408*params(37)*T1158+params(37)*T43*(-(y(4)/y(7)))/(y(25)*y(25))+T413*params(37)*y(61)*T360+T359*(-y(85))/y(82)/T403-T417*T1152*T1200;
  g1(20,82)=T413*T1236+T359*y(25)*y(85)/(y(82)*y(82))/T403;
  g1(20,7)=(y(7)*y(10)*params(38)*T1568/y(31)-y(10)*params(38)*T53/y(31))/(y(7)*y(7))+T408*params(37)*T1563+params(37)*T43*(-y(4))/(y(7)*y(7))/y(25);
  g1(20,28)=y(10)*params(38)*T1609/y(31)/y(7)+T404*T1639+T399*(-(y(31)*(-y(85))/y(88)*2*y(28)))/(T403*T403)+T408*params(37)*T1603+T413*T1623+T359*(-(y(25)*(-y(85))/y(82)*2*y(28)))/(T403*T403)-(T417*T1200*T1599+T385*params(26)*params(21)*getPowerDeriv(params(21)*y(28),T381,1));
  g1(20,85)=T404*T1693+T399*y(31)*(-1)/y(88)/T403+T413*T1685+T359*y(25)*(-1)/y(82)/T403;
  g1(20,10)=(params(38)*T53+y(10)*params(38)*T1992)/y(31)/y(7);
  g1(20,31)=(y(31)*y(10)*params(38)*T2030-y(10)*params(38)*T53)/(y(31)*y(31))/y(7)+T404*T2063+T399*(-y(85))/y(88)/T403-T417*T1200*T2025;
  g1(20,88)=T404*T2116+T399*y(31)*y(85)/(y(88)*y(88))/T403;
  g1(20,46)=1;
  g1(20,61)=T404*params(38)*T398+T413*params(37)*T358;
  g1(21,4)=(params(39)*T62+y(4)*params(39)*T1126)/y(25)/y(10);
  g1(21,25)=(y(25)*y(4)*params(39)*T1164-y(4)*params(39)*T62)/(y(25)*y(25))/y(10)+T429*T1193+T376*(-y(88))/y(82)/T428-T442*T1152*T1200;
  g1(21,82)=T429*T1244+T376*y(25)*y(88)/(y(82)*y(82))/T428;
  g1(21,7)=T434*params(38)*T1568+params(38)*T53*(-(y(10)*(-y(28))/T428))/(y(7)*y(7));
  g1(21,28)=T434*params(38)*T1609+params(38)*T53*y(10)*(-1)/T428/y(7)+(y(28)*y(85)*T1639/y(88)-y(85)*T399/y(88))/(y(28)*y(28))-T442*T1200*T1599;
  g1(21,85)=(T399+y(85)*T1693)/y(88)/y(28);
  g1(21,10)=(y(10)*y(4)*params(39)*T1998/y(25)-y(4)*params(39)*T62/y(25))/(y(10)*y(10))+T434*params(38)*T1992+params(38)*T53*(-y(28))/T428/y(7);
  g1(21,31)=y(4)*params(39)*T2034/y(25)/y(10)+T429*T2046+T376*(-(y(25)*(-y(88))/y(82)*2*y(31)))/(T428*T428)+T434*params(38)*T2030+params(38)*T53*y(10)*(-((-y(28))*2*y(31)))/(T428*T428)/y(7)+y(85)*T2063/y(88)/y(28)-(T442*T1200*T2025+T385*params(27)*params(23)*getPowerDeriv(params(23)*y(31),T381,1));
  g1(21,88)=T429*T2107+T376*y(25)*(-1)/y(82)/T428+(y(88)*y(85)*T2116-y(85)*T399)/(y(88)*y(88))/y(28);
  g1(21,49)=1;
  g1(21,61)=T429*params(39)*T375+y(85)*params(38)*T398/y(88)/y(28);
  g1(22,5)=(y(5)*y(8)*params(40)*T1265/y(29)-y(8)*params(40)*T98/y(29))/(y(5)*y(5))+T468*params(42)*T1271+params(42)*T117*(-y(11))/(y(5)*y(5))/y(32);
  g1(22,26)=y(8)*params(40)*T1307/y(29)/y(5)+T463*T1324+T458*(-(y(29)*(-y(83))/y(86)*2*y(26)))/(T462*T462)+T468*params(42)*T1313+T481*T1339+T477*y(83)*(-((-y(32))*2*y(26)))/(T462*T462)/y(89)-(T486*params(28)*params(19)*getPowerDeriv(params(19)*y(26),T381,1)+T485*T1302*T1352);
  g1(22,83)=T463*T1385+T458*y(29)*(-1)/y(86)/T462+T481*T1395+T477*(-y(32))/T462/y(89);
  g1(22,8)=(params(40)*T98+y(8)*params(40)*T1711)/y(29)/y(5);
  g1(22,29)=(y(29)*y(8)*params(40)*T1746-y(8)*params(40)*T98)/(y(29)*y(29))/y(5)+T463*T1763+T458*(-y(83))/y(86)/T462-T485*T1352*T1741;
  g1(22,86)=T463*T1821+T458*y(29)*y(83)/(y(86)*y(86))/T462;
  g1(22,11)=T468*params(42)*T2139+params(42)*T117*1/y(5)/y(32);
  g1(22,32)=T468*params(42)*T2179+params(42)*T117*(-(y(11)/y(5)))/(y(32)*y(32))+T481*T2190+T477*y(83)*(-1)/T462/y(89)-T485*T1352*T2170;
  g1(22,89)=T481*T2250+T477*(-(y(83)*(-y(32))/T462))/(y(89)*y(89));
  g1(22,44)=1;
  g1(22,62)=T463*params(40)*T457+T481*params(42)*T476;
  g1(23,5)=T509*params(40)*T1265+params(40)*T98*(-(y(8)*(-y(26))/T491))/(y(5)*y(5));
  g1(23,26)=T509*params(40)*T1307+params(40)*T98*y(8)*(-1)/T491/y(5)+(y(26)*y(83)*T1324/y(86)-y(83)*T458/y(86))/(y(26)*y(26))-T517*T1302*T1352;
  g1(23,83)=(T458+y(83)*T1385)/y(86)/y(26);
  g1(23,8)=T494*params(41)*T1715+params(41)*T108*(-y(32))/T491/y(11)+T509*params(40)*T1711+params(40)*T98*(-y(26))/T491/y(5);
  g1(23,29)=T494*params(41)*T1752+params(41)*T108*y(8)*(-((-y(32))*2*y(29)))/(T491*T491)/y(11)+T503*params(41)*y(62)*T503+T509*params(40)*T1746+params(40)*T98*y(8)*(-((-y(26))*2*y(29)))/(T491*T491)/y(5)+y(83)*T1763/y(86)/y(26)-(T517*T1352*T1741+T486*params(29)*getPowerDeriv(y(29),T381,1));
  g1(23,86)=T503*T1831+T502*(-y(89))/(y(86)*y(86))/y(32)+(y(86)*y(83)*T1821-y(83)*T458)/(y(86)*y(86))/y(26);
  g1(23,11)=T494*params(41)*T2135+params(41)*T108*(-(y(8)*(-y(32))/T491))/(y(11)*y(11));
  g1(23,32)=T494*params(41)*T2172+params(41)*T108*y(8)*(-1)/T491/y(11)+T503*T2208+T502*(-(y(89)/y(86)))/(y(32)*y(32))-T517*T1352*T2170;
  g1(23,89)=T503*T2257+T502*1/y(86)/y(32);
  g1(23,47)=1;
  g1(23,62)=T503*params(41)*T501+y(83)*params(40)*T457/y(86)/y(26);
  g1(24,5)=T525*params(42)*T1271+params(42)*T117*y(26)*y(11)/(y(5)*y(5))/T524;
  g1(24,26)=T525*params(42)*T1313+params(42)*T117*(-y(11))/y(5)/T524+y(32)*y(83)*T1339/y(89)-T543*T1302*T1352;
  g1(24,83)=y(32)*(T477+y(83)*T1395)/y(89);
  g1(24,8)=T533*params(41)*T1715+params(41)*T108*1/y(11)/y(29);
  g1(24,29)=T533*params(41)*T1752+params(41)*T108*(-(y(8)/y(11)))/(y(29)*y(29))+T539*params(41)*y(62)*T503+T502*(-y(89))/y(86)/T524-T543*T1352*T1741;
  g1(24,86)=T539*T1831+T502*y(29)*y(89)/(y(86)*y(86))/T524;
  g1(24,11)=T525*params(42)*T2139+params(42)*T117*y(26)*(-1)/y(5)/T524+T533*params(41)*T2135+params(41)*T108*(-y(8))/(y(11)*y(11))/y(29);
  g1(24,32)=T525*params(42)*T2179+params(42)*T117*(-(y(26)*(-y(11))/y(5)*2*y(32)))/(T524*T524)+y(83)*T477/y(89)+y(32)*y(83)*T2190/y(89)+T533*params(41)*T2172+T539*T2208+T502*(-(y(29)*(-y(89))/y(86)*2*y(32)))/(T524*T524)-(T543*T1352*T2170+T486*params(30)*params(24)*getPowerDeriv(params(24)*y(32),T381,1));
  g1(24,89)=y(32)*(y(89)*y(83)*T2250-y(83)*T477)/(y(89)*y(89))+T539*T2257+T502*y(29)*(-1)/y(86)/T524;
  g1(24,50)=1;
  g1(24,62)=y(32)*y(83)*params(42)*T476/y(89)+T539*params(41)*T501;
  g1(25,6)=(y(6)*y(9)*params(43)*T1411/y(30)-y(9)*params(43)*T153/y(30))/(y(6)*y(6))+T569*params(45)*T1417+params(45)*T172*1/y(12)/y(33);
  g1(25,27)=y(9)*params(43)*T1453/y(30)/y(6)+T564*T1470+T559*(-(y(30)*(-y(84))/y(87)*2*y(27)))/(T563*T563)+T569*params(45)*T1459+T581*T1485+T578*(-(y(33)*(-y(84))/y(90)*2*y(27)))/(T563*T563)-(T586*params(31)*params(20)*getPowerDeriv(params(20)*y(27),T381,1)+T585*T1448*T1496);
  g1(25,84)=T564*T1535+T559*y(30)*(-1)/y(87)/T563+T581*T1545+T578*y(33)*(-1)/y(90)/T563;
  g1(25,9)=(params(43)*T153+y(9)*params(43)*T1848)/y(30)/y(6);
  g1(25,30)=(y(30)*y(9)*params(43)*T1887-y(9)*params(43)*T153)/(y(30)*y(30))/y(6)+T564*T1902+T559*(-y(84))/y(87)/T563-T585*T1496*T1882;
  g1(25,87)=T564*T1969+T559*y(30)*y(84)/(y(87)*y(87))/T563;
  g1(25,12)=T569*params(45)*T2276+params(45)*T172*(-y(6))/(y(12)*y(12))/y(33);
  g1(25,33)=T569*params(45)*T2316+params(45)*T172*(-(y(6)/y(12)))/(y(33)*y(33))+T581*params(45)*y(62)*T630+T578*(-y(84))/y(90)/T563-T585*T1496*T2305;
  g1(25,90)=T581*T2387+T578*y(33)*y(84)/(y(90)*y(90))/T563;
  g1(25,45)=1;
  g1(25,62)=T564*params(43)*T558+T581*params(45)*T577;
  g1(26,6)=T611*params(43)*T1411+params(43)*T153*(-(y(9)*(-y(27))/T604))/(y(6)*y(6));
  g1(26,27)=T611*params(43)*T1453+params(43)*T153*y(9)*(-1)/T604/y(6)+(y(27)*y(84)*T1470/y(87)-y(84)*T559/y(87))/(y(27)*y(27))-T619*T1448*T1496;
  g1(26,84)=(T559+y(84)*T1535)/y(87)/y(27);
  g1(26,9)=(y(9)*y(12)*params(44)*T1854/y(33)-y(12)*params(44)*T163/y(33))/(y(9)*y(9))+T611*params(43)*T1848+params(43)*T153*(-y(27))/T604/y(6);
  g1(26,30)=y(12)*params(44)*T1891/y(33)/y(9)+T605*T1917+T600*(-(y(33)*(-y(87))/y(90)*2*y(30)))/(T604*T604)+T611*params(43)*T1887+params(43)*T153*y(9)*(-((-y(27))*2*y(30)))/(T604*T604)/y(6)+y(84)*T1902/y(87)/y(27)-(T619*T1496*T1882+T586*params(32)*params(22)*getPowerDeriv(params(22)*y(30),T381,1));
  g1(26,87)=T605*T1977+T600*y(33)*(-1)/y(90)/T604+(y(87)*y(84)*T1969-y(84)*T559)/(y(87)*y(87))/y(27);
  g1(26,12)=(params(44)*T163+y(12)*params(44)*T2272)/y(33)/y(9);
  g1(26,33)=(y(33)*y(12)*params(44)*T2310-y(12)*params(44)*T163)/(y(33)*y(33))/y(9)+T605*T2342+T600*(-y(87))/y(90)/T604-T619*T1496*T2305;
  g1(26,90)=T605*T2397+T600*y(33)*y(87)/(y(90)*y(90))/T604;
  g1(26,48)=1;
  g1(26,62)=T605*params(44)*T599+y(84)*params(43)*T558/y(87)/y(27);
  g1(27,6)=T627*params(45)*T1417+params(45)*T172*y(27)*y(12)/(y(6)*y(6))/T626;
  g1(27,27)=T627*params(45)*T1459+params(45)*T172*(-y(12))/y(6)/T626+T630*T1485+T578*(-(y(84)/y(90)))/(y(27)*y(27))-T644*T1448*T1496;
  g1(27,84)=T630*T1545+T578*1/y(90)/y(27);
  g1(27,9)=T636*params(44)*T1854+params(44)*T163*(-(y(12)*(-y(30))/T626))/(y(9)*y(9));
  g1(27,30)=T636*params(44)*T1891+params(44)*T163*y(12)*(-1)/T626/y(9)+(y(30)*y(87)*T1917/y(90)-y(87)*T600/y(90))/(y(30)*y(30))-T644*T1496*T1882;
  g1(27,87)=(T600+y(87)*T1977)/y(90)/y(30);
  g1(27,12)=T627*params(45)*T2276+params(45)*T172*y(27)*(-1)/y(6)/T626+T636*params(44)*T2272+params(44)*T163*(-y(30))/T626/y(9);
  g1(27,33)=T627*params(45)*T2316+params(45)*T172*(-(y(27)*(-y(12))/y(6)*2*y(33)))/(T626*T626)+T630*params(45)*y(62)*T630+T636*params(44)*T2310+params(44)*T163*y(12)*(-((-y(30))*2*y(33)))/(T626*T626)/y(9)+y(87)*T2342/y(90)/y(30)-(T644*T1496*T2305+T586*params(33)*getPowerDeriv(y(33),T381,1));
  g1(27,90)=T630*T2387+T578*(-y(84))/(y(90)*y(90))/y(27)+(y(90)*y(87)*T2397-y(87)*T600)/(y(90)*y(90))/y(30);
  g1(27,51)=1;
  g1(27,62)=T630*params(45)*T577+y(87)*params(44)*T599/y(90)/y(30);
  g1(28,19)=(-(T657*y(64)*y(52)*params(1)*getPowerDeriv(y(19),params(1)-1,1)));
  g1(28,22)=(-(T655*T1074));
  g1(28,34)=1;
  g1(28,52)=(-(T657*T654*y(64)*params(1)));
  g1(28,64)=(-(T657*T654*y(52)*params(1)));
  g1(29,19)=(-(T664*y(64)*y(52)*(1-params(1))*T962));
  g1(29,22)=(-(y(64)*y(52)*(1-params(1))*T661*getPowerDeriv(y(22),(-params(1)),1)));
  g1(29,37)=1;
  g1(29,52)=(-(T664*T661*y(64)*(1-params(1))));
  g1(29,64)=(-(T664*T661*y(52)*(1-params(1))));
  g1(30,20)=(-(T674*params(1)*y(65)*y(56)*getPowerDeriv(y(20),params(1)-1,1)));
  g1(30,23)=(-(T673*T1092));
  g1(30,35)=1;
  g1(30,56)=(-(T674*T672*params(1)*y(65)));
  g1(30,65)=(-(T674*T672*params(1)*y(56)));
  g1(31,20)=(-(T680*(1-params(1))*y(65)*y(56)*T1012));
  g1(31,23)=(-((1-params(1))*y(65)*y(56)*T678*getPowerDeriv(y(23),(-params(1)),1)));
  g1(31,38)=1;
  g1(31,56)=(-(T680*T678*(1-params(1))*y(65)));
  g1(31,65)=(-(T680*T678*(1-params(1))*y(56)));
  g1(32,21)=(-(T690*params(1)*y(66)*y(60)*getPowerDeriv(y(21),params(1)-1,1)));
  g1(32,24)=(-(T689*T1106));
  g1(32,36)=1;
  g1(32,60)=(-(T690*T688*params(1)*y(66)));
  g1(32,66)=(-(T690*T688*params(1)*y(60)));
  g1(33,21)=(-(T696*(1-params(1))*y(66)*y(60)*T1058));
  g1(33,24)=(-((1-params(1))*y(66)*y(60)*T694*getPowerDeriv(y(24),(-params(1)),1)));
  g1(33,39)=1;
  g1(33,60)=(-(T696*T694*(1-params(1))*y(66)));
  g1(33,66)=(-(T696*T694*(1-params(1))*y(60)));
  g1(34,43)=(-1);
  g1(34,52)=1;
  g1(35,44)=1;
  g1(35,53)=(-((1+params(13))/params(19)));
  g1(36,45)=1;
  g1(36,54)=(-((1+params(14))/params(20)));
  g1(37,46)=1;
  g1(37,55)=(-((1+params(15))/params(21)));
  g1(38,47)=(-1);
  g1(38,56)=1;
  g1(39,48)=1;
  g1(39,57)=(-((1+params(16))/params(22)));
  g1(40,49)=1;
  g1(40,58)=(-((1+params(17))/params(23)));
  g1(41,50)=1;
  g1(41,59)=(-((1+params(16))/params(22)));
  g1(42,51)=(-1);
  g1(42,60)=1;
  g1(43,40)=(-y(53));
  g1(43,52)=1;
  g1(43,53)=(-y(40));
  g1(44,40)=(-y(56));
  g1(44,55)=1;
  g1(44,56)=(-y(40));
  g1(45,40)=(-y(59));
  g1(45,58)=1;
  g1(45,59)=(-y(40));
  g1(46,41)=(-y(54));
  g1(46,52)=1;
  g1(46,54)=(-y(41));
  g1(47,41)=(-y(57));
  g1(47,55)=1;
  g1(47,57)=(-y(41));
  g1(48,41)=(-y(60));
  g1(48,58)=1;
  g1(48,60)=(-y(41));
  g1(49,19)=(-(y(64)*params(7)*T657*T962));
  g1(49,22)=(-(y(64)*params(7)*T661*T1074));
  g1(49,25)=params(7);
  g1(49,26)=params(8);
  g1(49,27)=params(9);
  g1(49,64)=(-(params(7)*T657*T661));
  g1(50,20)=(-(y(65)*params(8)*T674*T1012));
  g1(50,23)=(-(y(65)*params(8)*T678*T1092));
  g1(50,28)=params(7);
  g1(50,29)=params(8);
  g1(50,30)=params(9);
  g1(50,65)=(-(params(8)*T674*T678));
  g1(51,21)=(-(y(66)*params(9)*T690*T1058));
  g1(51,24)=(-(y(66)*params(9)*T694*T1106));
  g1(51,31)=params(7);
  g1(51,32)=params(8);
  g1(51,33)=params(9);
  g1(51,66)=(-(params(9)*T690*T694));
  g1(52,13)=(-(params(10)*1/y(13)));
  g1(52,64)=1/y(64);
  g1(52,97)=(-1);
  g1(53,14)=(-(params(11)*1/y(14)));
  g1(53,65)=1/y(65);
  g1(53,98)=(-1);
  g1(54,15)=(-(params(12)*1/y(15)));
  g1(54,66)=1/y(66);
  g1(54,99)=(-1);
  g1(55,21)=(-(params(9)*y(41)*(-0.5)*(-(y(66)*params(55)*T690*T1058))/params(7)/y(43)));
  g1(55,24)=(-(params(9)*y(41)*(-0.5)*(-(y(66)*params(55)*T694*T1106))/params(7)/y(43)));
  g1(55,27)=(-(params(9)*y(41)*(-0.5)*params(49)/params(7)/y(43)));
  g1(55,30)=(-(params(9)*y(41)*(-0.5)*params(52)/params(7)/y(43)));
  g1(55,33)=(-(params(9)*y(41)*(-0.5)*params(55)/params(7)/y(43)));
  g1(55,41)=(-((y(27)*params(49)+y(30)*params(52)+y(33)*params(55)-T690*T694*y(66)*params(55))*params(9)*(-0.5)/params(7)/y(43)));
  g1(55,43)=(-((-T819)/(y(43)*y(43))));
  g1(55,66)=(-(params(9)*y(41)*(-0.5)*(-(T690*T694*params(55)))/params(7)/y(43)));
  g1(55,71)=1;
  g1(56,19)=(-((-(y(64)*params(47)*T657*T962))/y(43)));
  g1(56,22)=(-((-(y(64)*params(47)*T661*T1074))/y(43)));
  g1(56,25)=(-(params(47)/y(43)));
  g1(56,28)=(-(params(50)/y(43)));
  g1(56,31)=(-(params(53)/y(43)));
  g1(56,43)=(-((-(y(25)*params(47)+y(28)*params(50)+y(31)*params(53)-T657*T661*y(64)*params(47)))/(y(43)*y(43))));
  g1(56,64)=(-((-(T657*T661*params(47)))/y(43)));
  g1(56,70)=1;
  g1(56,71)=1;
  g1(57,43)=(-((-y(46))/(y(43)*y(43))));
  g1(57,46)=(-(1/y(43)));
  g1(57,72)=1;
  g1(58,43)=(-((-y(49))/(y(43)*y(43))));
  g1(58,49)=(-(1/y(43)));
  g1(58,73)=1;
  g1(59,28)=(-(1-y(72)));
  g1(59,72)=y(28);
  g1(59,74)=1;
  g1(60,31)=(-(1-y(73)));
  g1(60,73)=y(31);
  g1(60,75)=1;
  g1(61,19)=y(64)*T657*T962;
  g1(61,22)=y(64)*T661*T1074;
  g1(61,25)=(-1);
  g1(61,28)=(-1);
  g1(61,31)=(-1);
  g1(61,64)=T657*T661;
  g1(61,74)=1;
  g1(61,75)=1;
  g1(61,76)=1;
  g1(62,19)=(-(y(64)*T657*T962));
  g1(62,22)=(-(y(64)*T661*T1074));
  g1(62,64)=(-(T657*T661));
  g1(62,77)=1;
  g1(63,20)=(-(y(65)*T674*T1012));
  g1(63,23)=(-(y(65)*T678*T1092));
  g1(63,65)=(-(T674*T678));
  g1(63,78)=1;

if nargout >= 3,
  %
  % Hessian matrix
  %

  g2 = sparse([],[],[],63,9801);
if nargout >= 4,
  %
  % Third order derivatives
  %

  g3 = sparse([],[],[],63,970299);
end
end
end
end
