function [residual, g1, g2, g3] = BKK3C_fg2nfKR_static(y, x, params)
%
% Status : Computes static model for Dynare
%
% Inputs : 
%   y         [M_.endo_nbr by 1] double    vector of endogenous variables in declaration order
%   x         [M_.exo_nbr by 1] double     vector of exogenous variables in declaration order
%   params    [M_.param_nbr by 1] double   vector of parameter values in declaration order
%
% Outputs:
%   residual  [M_.endo_nbr by 1] double    vector of residuals of the static model equations 
%                                          in order of declaration of the equations.
%                                          Dynare may prepend or append auxiliary equations, see M_.aux_vars
%   g1        [M_.endo_nbr by M_.endo_nbr] double    Jacobian matrix of the static model equations;
%                                                       columns: variables in declaration order
%                                                       rows: equations in order of declaration
%   g2        [M_.endo_nbr by (M_.endo_nbr)^2] double   Hessian matrix of the static model equations;
%                                                       columns: variables in declaration order
%                                                       rows: equations in order of declaration
%   g3        [M_.endo_nbr by (M_.endo_nbr)^3] double   Third derivatives matrix of the static model equations;
%                                                       columns: variables in declaration order
%                                                       rows: equations in order of declaration
%
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

residual = zeros( 63, 1);

%
% Model equations
%

T16 = (params(4)-1)/params(4);
T32 = params(25)*y(10)^T16+params(26)*(params(21)*y(13))^T16+params(27)*(params(23)*y(16))^T16;
T33 = params(4)/(params(4)-1);
T38 = y(13)/y(10);
T41 = y(10)*T38/y(13)-1;
T50 = y(16)*y(13)/y(16)/y(13)-1;
T59 = y(10)*y(16)/y(10)/y(16)-1;
T85 = params(28)*(params(19)*y(11))^T16+params(29)*y(14)^T16+params(30)*(params(24)*y(17))^T16;
T93 = y(14)*y(11)/y(14)/y(11)-1;
T99 = y(17)/y(14);
T102 = y(14)*T99/y(17)-1;
T111 = y(17)*y(11)/y(17)/y(11)-1;
T137 = params(31)*(params(20)*y(12))^T16+params(32)*(params(22)*y(15))^T16+params(33)*y(18)^T16;
T145 = y(15)*y(12)/y(15)/y(12)-1;
T154 = y(18)*y(15)/y(18)/y(15)-1;
T160 = y(12)/y(18);
T163 = y(18)*T160/y(12)-1;
T179 = (y(52)/y(4)-params(3))^2;
T191 = (y(53)/y(5)-params(3))^2;
T203 = (y(54)/y(6)-params(3))^2;
T210 = y(1)^(-params(2));
T213 = 1-params(46)*(y(52)/y(4)-params(3));
T214 = params(5)*T210/T213;
T218 = params(46)/2;
T219 = params(3)^2;
T223 = 1+y(19)-params(3)-T218*(T219-(y(52)/y(4))^2);
T228 = y(2)^(-params(2));
T231 = 1-params(46)*(y(53)/y(5)-params(3));
T232 = params(5)*T228/T231;
T239 = 1+y(20)-params(3)-T218*(T219-(y(53)/y(5))^2);
T244 = y(3)^(-params(2));
T247 = 1-params(46)*(y(54)/y(6)-params(3));
T248 = params(5)*T244/T247;
T255 = 1+y(21)-params(3)-T218*(T219-(y(54)/y(6))^2);
T313 = y(10)^2;
T321 = T38/y(13);
T328 = y(10)*(-y(16))/T313/y(16);
T337 = (-1)/params(4);
T339 = params(25)*y(10)^T337;
T340 = 1/(params(4)-1);
T341 = T32^T340;
T354 = y(13)^2;
T355 = y(16)*(-y(13))/y(16)/T354;
T359 = y(10)/y(13)/y(10);
T364 = y(10)*(-y(13))/y(10)/T354;
T368 = params(26)*(params(21)*y(13))^T337;
T378 = y(16)^2;
T379 = y(10)*(-y(16))/y(10)/T378;
T384 = y(16)*(-y(13))/T378/y(13);
T392 = params(27)*(params(23)*y(16))^T337;
T406 = y(11)^2;
T407 = y(14)*(-y(11))/y(14)/T406;
T412 = y(17)/y(11)/y(17);
T420 = y(11)*(-y(17))/T406/y(17);
T424 = params(28)*(params(19)*y(11))^T337;
T425 = T85^T340;
T430 = y(14)^2;
T433 = y(14)*(-y(17))/T430/y(17);
T438 = T99/y(17);
T443 = y(14)*(-y(11))/T430/y(11);
T451 = params(29)*y(14)^T337;
T457 = y(17)^2;
T458 = y(11)*(-y(17))/y(11)/T457;
T466 = y(14)/y(17)/y(14);
T471 = y(14)*(-y(17))/y(14)/T457;
T475 = params(30)*(params(24)*y(17))^T337;
T489 = y(12)^2;
T490 = y(15)*(-y(12))/y(15)/T489;
T501 = y(18)*(-y(12))/y(18)/T489;
T505 = params(31)*(params(20)*y(12))^T337;
T506 = T137^T340;
T520 = y(15)^2;
T521 = y(18)*(-y(15))/y(18)/T520;
T526 = y(15)*(-y(12))/T520/y(12);
T534 = params(32)*(params(22)*y(15))^T337;
T541 = y(18)^2;
T542 = y(12)*(-y(18))/y(12)/T541;
T545 = T160/y(12);
T550 = y(18)*(-y(15))/T541/y(15);
T558 = params(33)*y(18)^T337;
T567 = y(4)^(params(1)-1);
T568 = y(49)*y(37)*params(1)*T567;
T570 = y(7)^(1-params(1));
T574 = y(4)^params(1);
T577 = y(7)^(-params(1));
T584 = y(5)^(params(1)-1);
T585 = params(1)*y(50)*y(41)*T584;
T586 = y(8)^(1-params(1));
T590 = y(5)^params(1);
T592 = y(8)^(-params(1));
T599 = y(6)^(params(1)-1);
T600 = params(1)*y(51)*y(45)*T599;
T601 = y(9)^(1-params(1));
T605 = y(6)^params(1);
T607 = y(9)^(-params(1));
T724 = params(9)*y(26)*(-0.5)*(y(12)*params(49)+y(15)*params(52)+y(18)*params(55)-T601*T605*y(51)*params(55))/params(7);
residual(1) = (-y(1))-y(52)+T32^T33-params(37)/2*T41^2-params(38)/2*T50^2-params(39)/2*T59^2;
residual(2) = (-y(2))-y(53)+T85^T33-params(40)/2*T93^2-params(41)/2*T102^2-params(42)/2*T111^2;
residual(3) = (-y(3))-y(54)+T137^T33-params(43)/2*T145^2-params(44)/2*T154^2-params(45)/2*T163^2;
residual(4) = y(52)+(-y(4))+y(4)*(1-params(3))-y(4)*params(46)*T179;
residual(5) = y(53)+(-y(5))+(1-params(3))*y(5)-params(46)*y(5)*T191;
residual(6) = y(54)+(-y(6))+(1-params(3))*y(6)-params(46)*y(6)*T203;
residual(7) = T214*T223-T210/T213;
residual(8) = T232*T239-T228/T231;
residual(9) = T248*T255-T244/T247;
residual(10) = T210*(1-params(57))*y(22)-params(56)*y(7)^params(6);
residual(11) = T228*(1-params(57))*y(23)-params(56)*y(8)^params(6);
residual(12) = T244*(1-params(57))*y(24)-params(56)*y(9)^params(6);
lhs =y(25);
rhs =T228/T210*params(35);
residual(13)= lhs-rhs;
lhs =y(26);
rhs =T244/T210*params(36);
residual(14)= lhs-rhs;
lhs =y(27);
rhs =y(26)/y(25);
residual(15)= lhs-rhs;
lhs =y(46);
rhs =params(5)*T210/T210;
residual(16)= lhs-rhs;
lhs =y(47);
rhs =params(5)*T228/T228;
residual(17)= lhs-rhs;
lhs =y(48);
rhs =params(5)*T244/T244;
residual(18)= lhs-rhs;
lhs =y(28)+y(10)*params(37)*T41*(-y(13))/T313/y(13)+T41*params(37)*y(46)*T321+params(39)*T59*T328+y(16)*T59*params(39)*y(46)/y(10)/y(16);
rhs =T339*T341;
residual(19)= lhs-rhs;
lhs =y(31)+y(16)*params(38)*T50/y(16)/y(13)+T50*params(38)*y(46)*T355+params(37)*T41*T359+T41*params(37)*y(46)*T364;
rhs =T341*T368;
residual(20)= lhs-rhs;
lhs =y(34)+y(10)*params(39)*T59/y(10)/y(16)+T59*params(39)*y(46)*T379+params(38)*T50*T384+y(13)*T50*params(38)*y(46)/y(16)/y(13);
rhs =T341*T392;
residual(21)= lhs-rhs;
lhs =y(29)+y(14)*params(40)*T93/y(14)/y(11)+T93*params(40)*y(47)*T407+params(42)*T111*T412+T111*params(42)*y(47)*T420;
rhs =T424*T425;
residual(22)= lhs-rhs;
lhs =y(32)+params(41)*T102*T433+T102*params(41)*y(47)*T438+params(40)*T93*T443+y(11)*T93*params(40)*y(47)/y(14)/y(11);
rhs =T425*T451;
residual(23)= lhs-rhs;
lhs =y(35)+params(42)*T111*T458+y(17)*y(11)*T111*params(42)*y(47)/y(17)+params(41)*T102*T466+T102*params(41)*y(47)*T471;
rhs =T425*T475;
residual(24)= lhs-rhs;
lhs =y(30)+y(15)*params(43)*T145/y(15)/y(12)+T145*params(43)*y(47)*T490+params(45)*T163*T160/y(18)+T163*params(45)*y(47)*T501;
rhs =T505*T506;
residual(25)= lhs-rhs;
lhs =y(33)+y(18)*params(44)*T154/y(18)/y(15)+T154*params(44)*y(47)*T521+params(43)*T145*T526+y(12)*T145*params(43)*y(47)/y(15)/y(12);
rhs =T506*T534;
residual(26)= lhs-rhs;
lhs =y(36)+params(45)*T163*T542+T163*params(45)*y(47)*T545+params(44)*T154*T550+y(15)*T154*params(44)*y(47)/y(18)/y(15);
rhs =T506*T558;
residual(27)= lhs-rhs;
lhs =y(19);
rhs =T568*T570;
residual(28)= lhs-rhs;
lhs =y(22);
rhs =y(49)*y(37)*(1-params(1))*T574*T577;
residual(29)= lhs-rhs;
lhs =y(20);
rhs =T585*T586;
residual(30)= lhs-rhs;
lhs =y(23);
rhs =(1-params(1))*y(50)*y(41)*T590*T592;
residual(31)= lhs-rhs;
lhs =y(21);
rhs =T600*T601;
residual(32)= lhs-rhs;
lhs =y(24);
rhs =(1-params(1))*y(51)*y(45)*T605*T607;
residual(33)= lhs-rhs;
lhs =y(37);
rhs =y(28);
residual(34)= lhs-rhs;
lhs =y(29);
rhs =(1+params(13))*y(38)/params(19);
residual(35)= lhs-rhs;
lhs =y(30);
rhs =(1+params(14))*y(39)/params(20);
residual(36)= lhs-rhs;
lhs =y(31);
rhs =(1+params(15))*y(40)/params(21);
residual(37)= lhs-rhs;
lhs =y(41);
rhs =y(32);
residual(38)= lhs-rhs;
lhs =y(33);
rhs =(1+params(16))*y(42)/params(22);
residual(39)= lhs-rhs;
lhs =y(34);
rhs =(1+params(17))*y(43)/params(23);
residual(40)= lhs-rhs;
lhs =y(35);
rhs =(1+params(16))*y(44)/params(22);
residual(41)= lhs-rhs;
lhs =y(45);
rhs =y(36);
residual(42)= lhs-rhs;
lhs =y(37);
rhs =y(25)*y(38);
residual(43)= lhs-rhs;
lhs =y(40);
rhs =y(25)*y(41);
residual(44)= lhs-rhs;
lhs =y(43);
rhs =y(25)*y(44);
residual(45)= lhs-rhs;
lhs =y(37);
rhs =y(26)*y(39);
residual(46)= lhs-rhs;
lhs =y(40);
rhs =y(26)*y(42);
residual(47)= lhs-rhs;
lhs =y(43);
rhs =y(26)*y(45);
residual(48)= lhs-rhs;
lhs =y(10)*params(7)+y(11)*params(8)+y(12)*params(9);
rhs =y(49)*params(7)*T570*T574;
residual(49)= lhs-rhs;
lhs =y(13)*params(7)+y(14)*params(8)+y(15)*params(9);
rhs =y(50)*params(8)*T586*T590;
residual(50)= lhs-rhs;
lhs =y(16)*params(7)+y(17)*params(8)+y(18)*params(9);
rhs =y(51)*params(9)*T601*T605;
residual(51)= lhs-rhs;
lhs =log(y(49));
rhs =log(y(49))*params(10)+x(1);
residual(52)= lhs-rhs;
lhs =log(y(50));
rhs =log(y(50))*params(11)+x(2);
residual(53)= lhs-rhs;
lhs =log(y(51));
rhs =log(y(51))*params(12)+x(3);
residual(54)= lhs-rhs;
lhs =y(56);
rhs =T724/y(28);
residual(55)= lhs-rhs;
lhs =y(55);
rhs =(y(10)*params(47)+y(13)*params(50)+y(16)*params(53)-T570*T574*y(49)*params(47))/y(28)-y(56);
residual(56)= lhs-rhs;
lhs =y(57);
rhs =y(31)/y(28);
residual(57)= lhs-rhs;
lhs =y(58);
rhs =y(34)/y(28);
residual(58)= lhs-rhs;
lhs =y(59);
rhs =y(13)*(1-y(57));
residual(59)= lhs-rhs;
lhs =y(60);
rhs =y(16)*(1-y(58));
residual(60)= lhs-rhs;
lhs =y(61);
rhs =y(16)+y(10)+y(13)-y(59)-y(60)-y(49)*T570*T574;
residual(61)= lhs-rhs;
lhs =y(62);
rhs =y(49)*T570*T574;
residual(62)= lhs-rhs;
lhs =y(63);
rhs =y(50)*T586*T590;
residual(63)= lhs-rhs;
if ~isreal(residual)
  residual = real(residual)+imag(residual).^2;
end
if nargout >= 2,
  g1 = zeros(63, 63);

  %
  % Jacobian matrix
  %

T769 = getPowerDeriv(y(1),(-params(2)),1);
T792 = getPowerDeriv(y(2),(-params(2)),1);
T808 = getPowerDeriv(y(3),(-params(2)),1);
T856 = getPowerDeriv(y(4),params(1),1);
T900 = getPowerDeriv(y(5),params(1),1);
T940 = getPowerDeriv(y(6),params(1),1);
T956 = getPowerDeriv(y(7),1-params(1),1);
T974 = getPowerDeriv(y(8),1-params(1),1);
T988 = getPowerDeriv(y(9),1-params(1),1);
T1004 = params(25)*getPowerDeriv(y(10),T16,1);
T1005 = getPowerDeriv(T32,T33,1);
T1011 = (T38+y(10)*(-y(13))/(y(10)*y(10)))/y(13);
T1019 = (y(16)/y(10)+y(10)*(-y(16))/(y(10)*y(10)))/y(16);
T1062 = getPowerDeriv(T32,T340,1);
T1105 = params(28)*params(19)*getPowerDeriv(params(19)*y(11),T16,1);
T1106 = getPowerDeriv(T85,T33,1);
T1113 = (y(11)*y(14)*1/y(14)-y(14)*y(11)/y(14))/(y(11)*y(11));
T1122 = (y(11)*y(17)*1/y(17)-y(17)*y(11)/y(17))/(y(11)*y(11));
T1167 = getPowerDeriv(T85,T340,1);
T1206 = params(31)*params(20)*getPowerDeriv(params(20)*y(12),T16,1);
T1207 = getPowerDeriv(T137,T33,1);
T1214 = (y(12)*y(15)*1/y(15)-y(15)*y(12)/y(15))/(y(12)*y(12));
T1223 = (y(12)*y(18)*1/y(18)-y(18)*T160)/(y(12)*y(12));
T1267 = getPowerDeriv(T137,T340,1);
T1312 = params(26)*params(21)*getPowerDeriv(params(21)*y(13),T16,1);
T1319 = (y(13)*y(10)*1/y(10)-y(10)*T38)/(y(13)*y(13));
T1327 = (y(13)*y(16)*1/y(16)-y(16)*y(13)/y(16))/(y(13)*y(13));
T1416 = params(29)*getPowerDeriv(y(14),T16,1);
T1422 = (y(11)/y(14)+y(14)*(-y(11))/(y(14)*y(14)))/y(11);
T1429 = (T99+y(14)*(-y(17))/(y(14)*y(14)))/y(17);
T1511 = params(32)*params(22)*getPowerDeriv(params(22)*y(15),T16,1);
T1517 = (y(12)/y(15)+y(15)*(-y(12))/(y(15)*y(15)))/y(12);
T1523 = (y(15)*y(18)*1/y(18)-y(18)*y(15)/y(18))/(y(15)*y(15));
T1610 = params(27)*params(23)*getPowerDeriv(params(23)*y(16),T16,1);
T1616 = (y(13)/y(16)+y(16)*(-y(13))/(y(16)*y(16)))/y(13);
T1622 = (y(16)*y(10)*1/y(10)-y(10)*y(16)/y(10))/(y(16)*y(16));
T1706 = params(30)*params(24)*getPowerDeriv(params(24)*y(17),T16,1);
T1711 = (y(17)*y(14)*1/y(14)-y(14)*T99)/(y(17)*y(17));
T1718 = (y(11)/y(17)+y(17)*(-y(11))/(y(17)*y(17)))/y(11);
T1801 = params(33)*getPowerDeriv(y(18),T16,1);
T1807 = (y(15)/y(18)+y(18)*(-y(15))/(y(18)*y(18)))/y(15);
T1814 = (T160+y(18)*(-y(12))/(y(18)*y(18)))/y(12);
  g1(1,1)=(-1);
  g1(1,10)=T1004*T1005-params(37)/2*T1011*2*T41-params(39)/2*T1019*2*T59;
  g1(1,13)=T1005*T1312-params(37)/2*2*T41*T1319-params(38)/2*T1327*2*T50;
  g1(1,16)=T1005*T1610-params(38)/2*2*T50*T1616-params(39)/2*2*T59*T1622;
  g1(1,52)=(-1);
  g1(2,2)=(-1);
  g1(2,11)=T1105*T1106-params(40)/2*T1113*2*T93-params(42)/2*T1122*2*T111;
  g1(2,14)=T1106*T1416-params(40)/2*2*T93*T1422-params(41)/2*T1429*2*T102;
  g1(2,17)=T1106*T1706-params(41)/2*2*T102*T1711-params(42)/2*2*T111*T1718;
  g1(2,53)=(-1);
  g1(3,3)=(-1);
  g1(3,12)=T1206*T1207-params(43)/2*T1214*2*T145-params(45)/2*T1223*2*T163;
  g1(3,15)=T1207*T1511-params(43)/2*2*T145*T1517-params(44)/2*T1523*2*T154;
  g1(3,18)=T1207*T1801-params(44)/2*2*T154*T1807-params(45)/2*2*T163*T1814;
  g1(3,54)=(-1);
  g1(4,4)=(-1)+1-params(3)-(params(46)*T179+y(4)*params(46)*(-y(52))/(y(4)*y(4))*2*(y(52)/y(4)-params(3)));
  g1(4,52)=1-y(4)*params(46)*2*(y(52)/y(4)-params(3))*1/y(4);
  g1(5,5)=(-1)+1-params(3)-(params(46)*T191+params(46)*y(5)*(-y(53))/(y(5)*y(5))*2*(y(53)/y(5)-params(3)));
  g1(5,53)=1-params(46)*y(5)*2*(y(53)/y(5)-params(3))*1/y(5);
  g1(6,6)=(-1)+1-params(3)-(params(46)*T203+params(46)*y(6)*(-y(54))/(y(6)*y(6))*2*(y(54)/y(6)-params(3)));
  g1(6,54)=1-params(46)*y(6)*2*(y(54)/y(6)-params(3))*1/y(6);
  g1(7,1)=T223*params(5)*T769/T213-T769/T213;
  g1(7,4)=T223*(-(params(5)*T210*(-(params(46)*(-y(52))/(y(4)*y(4))))))/(T213*T213)+T214*(-(T218*(-((-y(52))/(y(4)*y(4))*2*y(52)/y(4)))))-(-(T210*(-(params(46)*(-y(52))/(y(4)*y(4))))))/(T213*T213);
  g1(7,19)=T214;
  g1(7,52)=T223*(-(params(5)*T210*(-(params(46)*1/y(4)))))/(T213*T213)+T214*(-(T218*(-(2*y(52)/y(4)*1/y(4)))))-(-(T210*(-(params(46)*1/y(4)))))/(T213*T213);
  g1(8,2)=T239*params(5)*T792/T231-T792/T231;
  g1(8,5)=T239*(-(params(5)*T228*(-(params(46)*(-y(53))/(y(5)*y(5))))))/(T231*T231)+T232*(-(T218*(-((-y(53))/(y(5)*y(5))*2*y(53)/y(5)))))-(-(T228*(-(params(46)*(-y(53))/(y(5)*y(5))))))/(T231*T231);
  g1(8,20)=T232;
  g1(8,53)=T239*(-(params(5)*T228*(-(params(46)*1/y(5)))))/(T231*T231)+T232*(-(T218*(-(2*y(53)/y(5)*1/y(5)))))-(-(T228*(-(params(46)*1/y(5)))))/(T231*T231);
  g1(9,3)=T255*params(5)*T808/T247-T808/T247;
  g1(9,6)=T255*(-(params(5)*T244*(-(params(46)*(-y(54))/(y(6)*y(6))))))/(T247*T247)+T248*(-(T218*(-((-y(54))/(y(6)*y(6))*2*y(54)/y(6)))))-(-(T244*(-(params(46)*(-y(54))/(y(6)*y(6))))))/(T247*T247);
  g1(9,21)=T248;
  g1(9,54)=T255*(-(params(5)*T244*(-(params(46)*1/y(6)))))/(T247*T247)+T248*(-(T218*(-(2*y(54)/y(6)*1/y(6)))))-(-(T244*(-(params(46)*1/y(6)))))/(T247*T247);
  g1(10,1)=(1-params(57))*y(22)*T769;
  g1(10,7)=(-(params(56)*getPowerDeriv(y(7),params(6),1)));
  g1(10,22)=T210*(1-params(57));
  g1(11,2)=(1-params(57))*y(23)*T792;
  g1(11,8)=(-(params(56)*getPowerDeriv(y(8),params(6),1)));
  g1(11,23)=T228*(1-params(57));
  g1(12,3)=(1-params(57))*y(24)*T808;
  g1(12,9)=(-(params(56)*getPowerDeriv(y(9),params(6),1)));
  g1(12,24)=T244*(1-params(57));
  g1(13,1)=(-(params(35)*(-(T228*T769))/(T210*T210)));
  g1(13,2)=(-(params(35)*T792/T210));
  g1(13,25)=1;
  g1(14,1)=(-(params(36)*(-(T244*T769))/(T210*T210)));
  g1(14,3)=(-(params(36)*T808/T210));
  g1(14,26)=1;
  g1(15,25)=(-((-y(26))/(y(25)*y(25))));
  g1(15,26)=(-(1/y(25)));
  g1(15,27)=1;
  g1(16,1)=(-((T210*params(5)*T769-params(5)*T210*T769)/(T210*T210)));
  g1(16,46)=1;
  g1(17,2)=(-((T228*params(5)*T792-params(5)*T228*T792)/(T228*T228)));
  g1(17,47)=1;
  g1(18,3)=(-((T244*params(5)*T808-params(5)*T244*T808)/(T244*T244)));
  g1(18,48)=1;
  g1(19,10)=(params(37)*T41*(-y(13))/T313+y(10)*((-y(13))/T313*params(37)*T1011+params(37)*T41*(-((-y(13))*2*y(10)))/(T313*T313)))/y(13)+T321*params(37)*y(46)*T1011+T41*params(37)*y(46)*(-y(13))/(y(10)*y(10))/y(13)+T328*params(39)*T1019+params(39)*T59*((-y(16))/T313+y(10)*(-((-y(16))*2*y(10)))/(T313*T313))/y(16)+(y(10)*y(16)*params(39)*y(46)*T1019-y(16)*T59*params(39)*y(46))/(y(10)*y(10))/y(16)-(T341*params(25)*getPowerDeriv(y(10),T337,1)+T339*T1004*T1062);
  g1(19,13)=(y(13)*y(10)*((-y(13))/T313*params(37)*T1319+params(37)*T41*(-1)/T313)-y(10)*params(37)*T41*(-y(13))/T313)/(y(13)*y(13))+T321*params(37)*y(46)*T1319+T41*params(37)*y(46)*(y(13)*1/y(10)-T38)/(y(13)*y(13))-T339*T1062*T1312;
  g1(19,16)=T328*params(39)*T1622+params(39)*T59*(y(16)*y(10)*(-1)/T313-y(10)*(-y(16))/T313)/(y(16)*y(16))+(y(16)*(T59*params(39)*y(46)+y(16)*params(39)*y(46)*T1622)/y(10)-y(16)*T59*params(39)*y(46)/y(10))/(y(16)*y(16))-T339*T1062*T1610;
  g1(19,28)=1;
  g1(19,46)=params(37)*T41*T321+y(16)*params(39)*T59/y(10)/y(16);
  g1(20,10)=T359*params(37)*T1011+params(37)*T41*(y(10)*1/y(13)-y(10)/y(13))/(y(10)*y(10))+T364*params(37)*y(46)*T1011+T41*params(37)*y(46)*((-y(13))/y(10)+y(10)*y(13)/(y(10)*y(10)))/T354-T368*T1004*T1062;
  g1(20,13)=(y(13)*y(16)*params(38)*T1327/y(16)-y(16)*params(38)*T50/y(16))/(y(13)*y(13))+T355*params(38)*y(46)*T1327+T50*params(38)*y(46)*(T354*y(16)*(-1)/y(16)-y(16)*(-y(13))/y(16)*2*y(13))/(T354*T354)+T359*params(37)*T1319+params(37)*T41*(-y(10))/(y(13)*y(13))/y(10)+T364*params(37)*y(46)*T1319+T41*params(37)*y(46)*(T354*y(10)*(-1)/y(10)-y(10)*(-y(13))/y(10)*2*y(13))/(T354*T354)-(T368*T1062*T1312+T341*params(26)*params(21)*getPowerDeriv(params(21)*y(13),T337,1));
  g1(20,16)=(y(16)*(params(38)*T50+y(16)*params(38)*T1616)-y(16)*params(38)*T50)/(y(16)*y(16))/y(13)+T355*params(38)*y(46)*T1616+T50*params(38)*y(46)*((-y(13))/y(16)+y(16)*y(13)/(y(16)*y(16)))/T354-T368*T1062*T1610;
  g1(20,31)=1;
  g1(20,46)=params(38)*T50*T355+params(37)*T41*T364;
  g1(21,10)=(y(10)*(params(39)*T59+y(10)*params(39)*T1019)-y(10)*params(39)*T59)/(y(10)*y(10))/y(16)+T379*params(39)*y(46)*T1019+T59*params(39)*y(46)*((-y(16))/y(10)+y(10)*y(16)/(y(10)*y(10)))/T378-T392*T1004*T1062;
  g1(21,13)=T384*params(38)*T1327+params(38)*T50*(y(13)*y(16)*(-1)/T378-y(16)*(-y(13))/T378)/(y(13)*y(13))+(y(13)*(T50*params(38)*y(46)+y(13)*params(38)*y(46)*T1327)/y(16)-y(13)*T50*params(38)*y(46)/y(16))/(y(13)*y(13))-T392*T1062*T1312;
  g1(21,16)=(y(16)*y(10)*params(39)*T1622/y(10)-y(10)*params(39)*T59/y(10))/(y(16)*y(16))+T379*params(39)*y(46)*T1622+T59*params(39)*y(46)*(T378*y(10)*(-1)/y(10)-y(10)*(-y(16))/y(10)*2*y(16))/(T378*T378)+T384*params(38)*T1616+params(38)*T50*((-y(13))/T378+y(16)*(-((-y(13))*2*y(16)))/(T378*T378))/y(13)+(y(16)*y(13)*params(38)*y(46)*T1616-y(13)*T50*params(38)*y(46))/(y(16)*y(16))/y(13)-(T392*T1062*T1610+T341*params(27)*params(23)*getPowerDeriv(params(23)*y(16),T337,1));
  g1(21,34)=1;
  g1(21,46)=params(39)*T59*T379+y(13)*params(38)*T50/y(16)/y(13);
  g1(22,11)=(y(11)*y(14)*params(40)*T1113/y(14)-y(14)*params(40)*T93/y(14))/(y(11)*y(11))+T407*params(40)*y(47)*T1113+T93*params(40)*y(47)*(T406*y(14)*(-1)/y(14)-y(14)*(-y(11))/y(14)*2*y(11))/(T406*T406)+T412*params(42)*T1122+params(42)*T111*(-y(17))/(y(11)*y(11))/y(17)+T420*params(42)*y(47)*T1122+T111*params(42)*y(47)*((-y(17))/T406+y(11)*(-((-y(17))*2*y(11)))/(T406*T406))/y(17)-(T425*params(28)*params(19)*getPowerDeriv(params(19)*y(11),T337,1)+T424*T1105*T1167);
  g1(22,14)=(y(14)*(params(40)*T93+y(14)*params(40)*T1422)-y(14)*params(40)*T93)/(y(14)*y(14))/y(11)+T407*params(40)*y(47)*T1422+T93*params(40)*y(47)*((-y(11))/y(14)+y(14)*y(11)/(y(14)*y(14)))/T406-T424*T1167*T1416;
  g1(22,17)=T412*params(42)*T1718+params(42)*T111*(y(17)*1/y(11)-y(17)/y(11))/(y(17)*y(17))+T420*params(42)*y(47)*T1718+T111*params(42)*y(47)*(y(17)*y(11)*(-1)/T406-y(11)*(-y(17))/T406)/(y(17)*y(17))-T424*T1167*T1706;
  g1(22,29)=1;
  g1(22,47)=params(40)*T93*T407+params(42)*T111*T420;
  g1(23,11)=T443*params(40)*T1113+params(40)*T93*(y(11)*y(14)*(-1)/T430-y(14)*(-y(11))/T430)/(y(11)*y(11))+(y(11)*(T93*params(40)*y(47)+y(11)*params(40)*y(47)*T1113)/y(14)-y(11)*T93*params(40)*y(47)/y(14))/(y(11)*y(11))-T451*T1105*T1167;
  g1(23,14)=T433*params(41)*T1429+params(41)*T102*((-y(17))/T430+y(14)*(-((-y(17))*2*y(14)))/(T430*T430))/y(17)+T438*params(41)*y(47)*T1429+T102*params(41)*y(47)*(-y(17))/(y(14)*y(14))/y(17)+T443*params(40)*T1422+params(40)*T93*((-y(11))/T430+y(14)*(-((-y(11))*2*y(14)))/(T430*T430))/y(11)+(y(14)*y(11)*params(40)*y(47)*T1422-y(11)*T93*params(40)*y(47))/(y(14)*y(14))/y(11)-(T451*T1167*T1416+T425*params(29)*getPowerDeriv(y(14),T337,1));
  g1(23,17)=T433*params(41)*T1711+params(41)*T102*(y(17)*y(14)*(-1)/T430-y(14)*(-y(17))/T430)/(y(17)*y(17))+T438*params(41)*y(47)*T1711+T102*params(41)*y(47)*(y(17)*1/y(14)-T99)/(y(17)*y(17))-T451*T1167*T1706;
  g1(23,32)=1;
  g1(23,47)=params(41)*T102*T438+y(11)*params(40)*T93/y(14)/y(11);
  g1(24,11)=T458*params(42)*T1122+params(42)*T111*((-y(17))/y(11)+y(11)*y(17)/(y(11)*y(11)))/T457+y(17)*(T111*params(42)*y(47)+y(11)*params(42)*y(47)*T1122)/y(17)-T475*T1105*T1167;
  g1(24,14)=T466*params(41)*T1429+params(41)*T102*(y(14)*1/y(17)-y(14)/y(17))/(y(14)*y(14))+T471*params(41)*y(47)*T1429+T102*params(41)*y(47)*((-y(17))/y(14)+y(14)*y(17)/(y(14)*y(14)))/T457-T475*T1167*T1416;
  g1(24,17)=T458*params(42)*T1718+params(42)*T111*(T457*y(11)*(-1)/y(11)-y(11)*(-y(17))/y(11)*2*y(17))/(T457*T457)+y(11)*T111*params(42)*y(47)/y(17)+y(17)*(y(17)*y(11)*params(42)*y(47)*T1718-y(11)*T111*params(42)*y(47))/(y(17)*y(17))+T466*params(41)*T1711+params(41)*T102*(-y(14))/(y(17)*y(17))/y(14)+T471*params(41)*y(47)*T1711+T102*params(41)*y(47)*(T457*y(14)*(-1)/y(14)-y(14)*(-y(17))/y(14)*2*y(17))/(T457*T457)-(T475*T1167*T1706+T425*params(30)*params(24)*getPowerDeriv(params(24)*y(17),T337,1));
  g1(24,35)=1;
  g1(24,47)=y(17)*y(11)*params(42)*T111/y(17)+params(41)*T102*T471;
  g1(25,12)=(y(12)*y(15)*params(43)*T1214/y(15)-y(15)*params(43)*T145/y(15))/(y(12)*y(12))+T490*params(43)*y(47)*T1214+T145*params(43)*y(47)*(T489*y(15)*(-1)/y(15)-y(15)*(-y(12))/y(15)*2*y(12))/(T489*T489)+T160/y(18)*params(45)*T1223+params(45)*T163*1/y(18)/y(18)+T501*params(45)*y(47)*T1223+T163*params(45)*y(47)*(T489*y(18)*(-1)/y(18)-y(18)*(-y(12))/y(18)*2*y(12))/(T489*T489)-(T506*params(31)*params(20)*getPowerDeriv(params(20)*y(12),T337,1)+T505*T1206*T1267);
  g1(25,15)=(y(15)*(params(43)*T145+y(15)*params(43)*T1517)-y(15)*params(43)*T145)/(y(15)*y(15))/y(12)+T490*params(43)*y(47)*T1517+T145*params(43)*y(47)*((-y(12))/y(15)+y(15)*y(12)/(y(15)*y(15)))/T489-T505*T1267*T1511;
  g1(25,18)=T160/y(18)*params(45)*T1814+params(45)*T163*(y(18)*(-y(12))/(y(18)*y(18))-T160)/(y(18)*y(18))+T501*params(45)*y(47)*T1814+T163*params(45)*y(47)*((-y(12))/y(18)+y(18)*y(12)/(y(18)*y(18)))/T489-T505*T1267*T1801;
  g1(25,30)=1;
  g1(25,47)=params(43)*T145*T490+params(45)*T163*T501;
  g1(26,12)=T526*params(43)*T1214+params(43)*T145*(y(12)*y(15)*(-1)/T520-y(15)*(-y(12))/T520)/(y(12)*y(12))+(y(12)*(T145*params(43)*y(47)+y(12)*params(43)*y(47)*T1214)/y(15)-y(12)*T145*params(43)*y(47)/y(15))/(y(12)*y(12))-T534*T1206*T1267;
  g1(26,15)=(y(15)*y(18)*params(44)*T1523/y(18)-y(18)*params(44)*T154/y(18))/(y(15)*y(15))+T521*params(44)*y(47)*T1523+T154*params(44)*y(47)*(T520*y(18)*(-1)/y(18)-y(18)*(-y(15))/y(18)*2*y(15))/(T520*T520)+T526*params(43)*T1517+params(43)*T145*((-y(12))/T520+y(15)*(-((-y(12))*2*y(15)))/(T520*T520))/y(12)+(y(15)*y(12)*params(43)*y(47)*T1517-y(12)*T145*params(43)*y(47))/(y(15)*y(15))/y(12)-(T534*T1267*T1511+T506*params(32)*params(22)*getPowerDeriv(params(22)*y(15),T337,1));
  g1(26,18)=(y(18)*(params(44)*T154+y(18)*params(44)*T1807)-y(18)*params(44)*T154)/(y(18)*y(18))/y(15)+T521*params(44)*y(47)*T1807+T154*params(44)*y(47)*((-y(15))/y(18)+y(18)*y(15)/(y(18)*y(18)))/T520-T534*T1267*T1801;
  g1(26,33)=1;
  g1(26,47)=params(44)*T154*T521+y(12)*params(43)*T145/y(15)/y(12);
  g1(27,12)=T542*params(45)*T1223+params(45)*T163*((-y(18))/y(12)+y(12)*y(18)/(y(12)*y(12)))/T541+T545*params(45)*y(47)*T1223+T163*params(45)*y(47)*(y(12)*1/y(18)-T160)/(y(12)*y(12))-T558*T1206*T1267;
  g1(27,15)=T550*params(44)*T1523+params(44)*T154*(y(15)*y(18)*(-1)/T541-y(18)*(-y(15))/T541)/(y(15)*y(15))+(y(15)*(T154*params(44)*y(47)+y(15)*params(44)*y(47)*T1523)/y(18)-y(15)*T154*params(44)*y(47)/y(18))/(y(15)*y(15))-T558*T1267*T1511;
  g1(27,18)=T542*params(45)*T1814+params(45)*T163*(T541*y(12)*(-1)/y(12)-y(12)*(-y(18))/y(12)*2*y(18))/(T541*T541)+T545*params(45)*y(47)*T1814+T163*params(45)*y(47)*(-y(12))/(y(18)*y(18))/y(12)+T550*params(44)*T1807+params(44)*T154*((-y(15))/T541+y(18)*(-((-y(15))*2*y(18)))/(T541*T541))/y(15)+(y(18)*y(15)*params(44)*y(47)*T1807-y(15)*T154*params(44)*y(47))/(y(18)*y(18))/y(15)-(T558*T1267*T1801+T506*params(33)*getPowerDeriv(y(18),T337,1));
  g1(27,36)=1;
  g1(27,47)=params(45)*T163*T545+y(15)*params(44)*T154/y(18)/y(15);
  g1(28,4)=(-(T570*y(49)*y(37)*params(1)*getPowerDeriv(y(4),params(1)-1,1)));
  g1(28,7)=(-(T568*T956));
  g1(28,19)=1;
  g1(28,37)=(-(T570*T567*y(49)*params(1)));
  g1(28,49)=(-(T570*T567*y(37)*params(1)));
  g1(29,4)=(-(T577*y(49)*y(37)*(1-params(1))*T856));
  g1(29,7)=(-(y(49)*y(37)*(1-params(1))*T574*getPowerDeriv(y(7),(-params(1)),1)));
  g1(29,22)=1;
  g1(29,37)=(-(T577*T574*y(49)*(1-params(1))));
  g1(29,49)=(-(T577*T574*y(37)*(1-params(1))));
  g1(30,5)=(-(T586*params(1)*y(50)*y(41)*getPowerDeriv(y(5),params(1)-1,1)));
  g1(30,8)=(-(T585*T974));
  g1(30,20)=1;
  g1(30,41)=(-(T586*T584*params(1)*y(50)));
  g1(30,50)=(-(T586*T584*params(1)*y(41)));
  g1(31,5)=(-(T592*(1-params(1))*y(50)*y(41)*T900));
  g1(31,8)=(-((1-params(1))*y(50)*y(41)*T590*getPowerDeriv(y(8),(-params(1)),1)));
  g1(31,23)=1;
  g1(31,41)=(-(T592*T590*(1-params(1))*y(50)));
  g1(31,50)=(-(T592*T590*(1-params(1))*y(41)));
  g1(32,6)=(-(T601*params(1)*y(51)*y(45)*getPowerDeriv(y(6),params(1)-1,1)));
  g1(32,9)=(-(T600*T988));
  g1(32,21)=1;
  g1(32,45)=(-(T601*T599*params(1)*y(51)));
  g1(32,51)=(-(T601*T599*params(1)*y(45)));
  g1(33,6)=(-(T607*(1-params(1))*y(51)*y(45)*T940));
  g1(33,9)=(-((1-params(1))*y(51)*y(45)*T605*getPowerDeriv(y(9),(-params(1)),1)));
  g1(33,24)=1;
  g1(33,45)=(-(T607*T605*(1-params(1))*y(51)));
  g1(33,51)=(-(T607*T605*(1-params(1))*y(45)));
  g1(34,28)=(-1);
  g1(34,37)=1;
  g1(35,29)=1;
  g1(35,38)=(-((1+params(13))/params(19)));
  g1(36,30)=1;
  g1(36,39)=(-((1+params(14))/params(20)));
  g1(37,31)=1;
  g1(37,40)=(-((1+params(15))/params(21)));
  g1(38,32)=(-1);
  g1(38,41)=1;
  g1(39,33)=1;
  g1(39,42)=(-((1+params(16))/params(22)));
  g1(40,34)=1;
  g1(40,43)=(-((1+params(17))/params(23)));
  g1(41,35)=1;
  g1(41,44)=(-((1+params(16))/params(22)));
  g1(42,36)=(-1);
  g1(42,45)=1;
  g1(43,25)=(-y(38));
  g1(43,37)=1;
  g1(43,38)=(-y(25));
  g1(44,25)=(-y(41));
  g1(44,40)=1;
  g1(44,41)=(-y(25));
  g1(45,25)=(-y(44));
  g1(45,43)=1;
  g1(45,44)=(-y(25));
  g1(46,26)=(-y(39));
  g1(46,37)=1;
  g1(46,39)=(-y(26));
  g1(47,26)=(-y(42));
  g1(47,40)=1;
  g1(47,42)=(-y(26));
  g1(48,26)=(-y(45));
  g1(48,43)=1;
  g1(48,45)=(-y(26));
  g1(49,4)=(-(y(49)*params(7)*T570*T856));
  g1(49,7)=(-(y(49)*params(7)*T574*T956));
  g1(49,10)=params(7);
  g1(49,11)=params(8);
  g1(49,12)=params(9);
  g1(49,49)=(-(params(7)*T570*T574));
  g1(50,5)=(-(y(50)*params(8)*T586*T900));
  g1(50,8)=(-(y(50)*params(8)*T590*T974));
  g1(50,13)=params(7);
  g1(50,14)=params(8);
  g1(50,15)=params(9);
  g1(50,50)=(-(params(8)*T586*T590));
  g1(51,6)=(-(y(51)*params(9)*T601*T940));
  g1(51,9)=(-(y(51)*params(9)*T605*T988));
  g1(51,16)=params(7);
  g1(51,17)=params(8);
  g1(51,18)=params(9);
  g1(51,51)=(-(params(9)*T601*T605));
  g1(52,49)=1/y(49)-params(10)*1/y(49);
  g1(53,50)=1/y(50)-params(11)*1/y(50);
  g1(54,51)=1/y(51)-params(12)*1/y(51);
  g1(55,6)=(-(params(9)*y(26)*(-0.5)*(-(y(51)*params(55)*T601*T940))/params(7)/y(28)));
  g1(55,9)=(-(params(9)*y(26)*(-0.5)*(-(y(51)*params(55)*T605*T988))/params(7)/y(28)));
  g1(55,12)=(-(params(9)*y(26)*(-0.5)*params(49)/params(7)/y(28)));
  g1(55,15)=(-(params(9)*y(26)*(-0.5)*params(52)/params(7)/y(28)));
  g1(55,18)=(-(params(9)*y(26)*(-0.5)*params(55)/params(7)/y(28)));
  g1(55,26)=(-((y(12)*params(49)+y(15)*params(52)+y(18)*params(55)-T601*T605*y(51)*params(55))*params(9)*(-0.5)/params(7)/y(28)));
  g1(55,28)=(-((-T724)/(y(28)*y(28))));
  g1(55,51)=(-(params(9)*y(26)*(-0.5)*(-(T601*T605*params(55)))/params(7)/y(28)));
  g1(55,56)=1;
  g1(56,4)=(-((-(y(49)*params(47)*T570*T856))/y(28)));
  g1(56,7)=(-((-(y(49)*params(47)*T574*T956))/y(28)));
  g1(56,10)=(-(params(47)/y(28)));
  g1(56,13)=(-(params(50)/y(28)));
  g1(56,16)=(-(params(53)/y(28)));
  g1(56,28)=(-((-(y(10)*params(47)+y(13)*params(50)+y(16)*params(53)-T570*T574*y(49)*params(47)))/(y(28)*y(28))));
  g1(56,49)=(-((-(T570*T574*params(47)))/y(28)));
  g1(56,55)=1;
  g1(56,56)=1;
  g1(57,28)=(-((-y(31))/(y(28)*y(28))));
  g1(57,31)=(-(1/y(28)));
  g1(57,57)=1;
  g1(58,28)=(-((-y(34))/(y(28)*y(28))));
  g1(58,34)=(-(1/y(28)));
  g1(58,58)=1;
  g1(59,13)=(-(1-y(57)));
  g1(59,57)=y(13);
  g1(59,59)=1;
  g1(60,16)=(-(1-y(58)));
  g1(60,58)=y(16);
  g1(60,60)=1;
  g1(61,4)=y(49)*T570*T856;
  g1(61,7)=y(49)*T574*T956;
  g1(61,10)=(-1);
  g1(61,13)=(-1);
  g1(61,16)=(-1);
  g1(61,49)=T570*T574;
  g1(61,59)=1;
  g1(61,60)=1;
  g1(61,61)=1;
  g1(62,4)=(-(y(49)*T570*T856));
  g1(62,7)=(-(y(49)*T574*T956));
  g1(62,49)=(-(T570*T574));
  g1(62,62)=1;
  g1(63,5)=(-(y(50)*T586*T900));
  g1(63,8)=(-(y(50)*T590*T974));
  g1(63,50)=(-(T586*T590));
  g1(63,63)=1;
  if ~isreal(g1)
    g1 = real(g1)+2*imag(g1);
  end
if nargout >= 3,
  %
  % Hessian matrix
  %

  g2 = sparse([],[],[],63,3969);
if nargout >= 4,
  %
  % Third order derivatives
  %

  g3 = sparse([],[],[],63,250047);
end
end
end
end
