%this code runs the p50 and p90 versions of all the models and generates
%the slope coefficients for the trade-comovement puzzle.
%for the business cycle statistics, run the p50 .m files listed below.


clc 
clear
close all
cd ./BKK_Model_friction/
%these files solve the DTE model
 BKK_friction_p90
 BKK_friction_p50
 cd ..
 cd ./BKK_Model_fg_nofriction/
  %these files solve the baseline model
  %for elastictity 1.17
 BKK_nof_p50_gam117
 BKK_nof_p90_gam117
 %and for elasticity 15
 BKK_nof_p50_gam15
 BKK_nof_p90_gam15
 cd ..
   cd ./BKK_Model_nof_KR/
 %these files solve the model with separable utiliy between consumption and labor
 %for labor elasticity 1
 BKK_nof_p50_KR
 BKK_nof_p90_KR
 %and labor elasticity 2
 BKK_nof_p50_KR2
 BKK_nof_p90_KR2
 cd ..
 cd ./BKK_Model_friction_AUT/
 %these files solve the autarky equilibirum
 BKK_aut_p90
 BKK_aut_p50
cd ..
cd ./BKK_Model_GHH2/
%these files solve the model with GHH preferences
%Frisch elasticity 1
BKK_p50GHH2_elast
BKK_p90GHH2_elast
%these files solve the model with GHH preferences
%Frisch elasticity 4/3
BKK_p50GHH2_43
BKK_p90GHH2_43
%Frisch elasticity 1 but trade elasticity 2
BKK_p90GHH_medelast
BKK_p50GHH_medelast
%Frisch elasticity 1/2
BKK_p90GHH_el2
BKK_p50GHH_el2
%Frisch elasticity 2
BKK_p90GHH_el3
BKK_p50GHH_el3
cd ..
%Comparison to other models (Appendix)
p90      =load('./BKK_Model_friction/Data90.txt');
p50      =load('./BKK_Model_friction/Data50.txt');
p90bkk_117      =load('./BKK_Model_fg_nofriction/Data90_117.txt');
p50bkk_117      =load('./BKK_Model_fg_nofriction/Data50_117.txt');
p90bkk_15      =load('./BKK_Model_fg_nofriction/Data90_15.txt');
p50bkk_15      =load('./BKK_Model_fg_nofriction/Data50_15.txt');
p90KR      =load('./BKK_Model_nof_KR/Data90_117KR.txt');
p50KR      =load('./BKK_Model_nof_KR/Data50_117KR.txt');
p90KR2     =load('./BKK_Model_nof_KR/Data90_117KR2.txt');
p50KR2      =load('./BKK_Model_nof_KR/Data50_117KR2.txt');
p90aut   =load('./BKK_Model_friction_AUT/Data90.txt');
p50aut   =load('./BKK_Model_friction_AUT/Data50.txt');
p90GHHnf   =load('./BKK_Model_GHH2/Data90.txt');
p50GHHnf   =load('./BKK_Model_GHH2/Data50.txt');
p90GHHnf_med   =load('./BKK_Model_GHH2/Data90_medelast.txt');
p50GHHnf_med   =load('./BKK_Model_GHH2/Data50_medelast.txt');
p90GHHnf_43   =load('./BKK_Model_GHH2/Data90_43.txt');
p50GHHnf_43   =load('./BKK_Model_GHH2/Data50_43.txt');
p90GHHnf_el2   =load('./BKK_Model_GHH2/Data90_el2.txt');
p50GHHnf_el2   =load('./BKK_Model_GHH2/Data50_el2.txt');
p90GHHnf_el3   =load('./BKK_Model_GHH2/Data90_el3.txt');
p50GHHnf_el3   =load('./BKK_Model_GHH2/Data50_el3.txt');

slopeM=(p90(1)-p50(1))/(log(p90(4))-log(p50(4)))
slopeBKK117=(p90bkk_117(1)-p50bkk_117(1))/(log(p90bkk_117(4))-log(p50bkk_117(4)))
slopeKR=(p90KR(1)-p50KR(1))/(log(p90KR(4))-log(p50KR(4)))
slopeKR2=(p90KR2(1)-p50KR2(1))/(log(p90KR2(4))-log(p50KR2(4)))
slopeBKK15=(p90bkk_15(1)-p50bkk_15(1))/(log(p90bkk_15(4))-log(p50bkk_15(4)))
slopeGHHnf=(p90GHHnf(1)-p50GHHnf(1))/(log(p90GHHnf(4))-log(p50GHHnf(4)))
slopeGHHnf_med=(p90GHHnf_med(1)-p50GHHnf_med(1))/(log(p90GHHnf_med(4))-log(p50GHHnf_med(4)))
slopeGHHnf_43=(p90GHHnf_43(1)-p50GHHnf_43(1))/(log(p90GHHnf_43(4))-log(p50GHHnf_43(4)))
slopeGHHnf_el2=(p90GHHnf_el2(1)-p50GHHnf_el2(1))/(log(p90GHHnf_el2(4))-log(p50GHHnf_el2(4)))
slopeGHHnf_el3=(p90GHHnf_el3(1)-p50GHHnf_el3(1))/(log(p90GHHnf_el3(4))-log(p50GHHnf_el3(4)))
slopeMaut=(p90aut(1)-p50aut(1))/(log(p90aut(4))-log(p50aut(4)))
slopeD=0.034
disp('Ratio of coefficients Model/Data for BKK with friction, autarky, GHH, etc')
Ratio=slopeM/slopeD;

 RatioAut=slopeMaut/slopeD;
 RatioGHHnf = slopeGHHnf/slopeD;
 RatioGHHnf_med = slopeGHHnf_med/slopeD;
 RatioGHHnf_43 = slopeGHHnf_43/slopeD;
 RatioGHHnf_el2 = slopeGHHnf_el2/slopeD;
 RatioGHHnf_el3 = slopeGHHnf_el3/slopeD;
 RatioBKK117=slopeBKK117/slopeD;
 RatioBKK15=slopeBKK15/slopeD;
 RatioKR=slopeKR/slopeD;
 RatioKR2=slopeKR2/slopeD;
 fprintf('Ratio of coefficients Model/Data for baseline model with elasticity 1.1.7: %3.2f\n',RatioBKK117)
 fprintf('Ratio of coefficients Model/Data for DTE model: %3.2f\n',Ratio)
 fprintf('Ratio of coefficients Model/Data for baseline model with Financial Autarky: %3.2f\n',RatioAut)
 fprintf('Ratio of coefficients Model/Data for model with GHH preferences: %3.2f\n',RatioGHHnf)
 fprintf('Ratio of coefficients Model/Data for model with GHH preferences, Frisch elasticity 1 but trade elasticity 2: %3.2f\n',RatioGHHnf_med)
 fprintf('Ratio of coefficients Model/Data for model with GHH preferences, Frisch elasticity 4/3: %3.2f\n',RatioGHHnf_43)
 fprintf('Ratio of coefficients Model/Data for model with GHH preferences and Frisch elasticity 2: %3.2f\n',RatioGHHnf_el3)
 fprintf('Ratio of coefficients Model/Data for model with GHH preferences and Frisch elasticity 1/2: %3.2f\n',RatioGHHnf_el2)
 fprintf('Ratio of coefficients Model/Data for model with separable utility and labor elasticity 1: %3.2f\n',RatioKR)
 fprintf('Ratio of coefficients Model/Data for model with separable utility and labor elasticity 2: %3.2f\n',RatioKR2)












