(* ::Package:: *)

(* ::Input:: *)
(*(*:Name: Log-linearization tools*)*)
(*(*:Author: Drozd, Kolbin and Nosal*)*)
(*(*:Last updated: Dec 2019*)*)


(* ::Input:: *)
(*BeginPackage["`Loglintools`"]*)


(* ::Input:: *)
(*Begin["`Private`"]*)


(* ::Text:: *)
(*Linearization routine:*)


(* ::Input:: *)
(*Linearize::usage="Linearize[f,x,x0] linearizes a list of equations f with respect to x at x0."*)


(* ::Input:: *)
(*Linearize[f_,x_,x0_]:=Module[{df,df0,f0},f0=f[[1]]/.Thread[x->x0]//FullSimplify;df=D[f[[1]],{x}]; df0=df/.Thread[x->x0]//FullSimplify;Thread[f0+df0.x==0]]*)


(* ::Text:: *)
(*Log-linearization routine: *)


(* ::Input:: *)
(*LogLinearize::usage="LogLinearize[f,x,x0] log-linearizes a list of equations f with respect to x at x0."*)


(* ::Input:: *)
(*LogLinearize[f_,x_,x0_]:=Module[{ff,df,df0,lx,ex,f0},f0=f[[1]]/.Thread[x->x0]//FullSimplify;lx=Exp[x];ff=f[[1]]/.Thread[x->lx];df=D[ff,{x}];ex=Log[x0];df0=df/.Thread[x->ex]//FullSimplify;Thread[(f0+df0.x)==0]]*)


(* ::Text:: *)
(*Mixed routine:*)


(* ::Input:: *)
(*LogLinearizeE::usage="LogLinearizeE[f_,x_,y_,x0_,y0_] log-linearizes a list of equations f with respect to list of variables x at x0 and linearizes with respect to list of variables y at y0."*)


(* ::Input:: *)
(*LogLinearizeE[f_,x_,y_,x0_,y0_]:=Module[{ff,dfx,dfy,df0x,df0y,lx,ex,f0},f0=f[[1]]/.Thread[x->x0]/.Thread[y->y0]//FullSimplify;lx=Exp[x];ff=f[[1]]/.Thread[x->lx];dfx=D[ff,{x}];ex=Log[x0];df0x=dfx/.Thread[x->ex]/.Thread[y->y0]//FullSimplify; dfy=D[f[[1]],{y}];df0y=dfy/.Thread[y->y0]/.Thread[x-> x0]//FullSimplify;Thread[(f0+df0x.x+df0y.y)==0]]*)


(* ::Input:: *)
(*End[]*)


(* ::Input:: *)
(*EndPackage[]*)
